/****************************************************************************/
/* T  vF SD J[hhCo												*/
/*   F SDJ[hSCIgpđ삷hCo							*/
/*           SD J[hƂĕI I/O ȂB						*/
/*           ̂ CSD ǂݍ݃J[hTCYAubNTCYȂǕ	*/
/*          IȏŕێB										*/
/* 쐬F 2004.10.09														*/
/* XVF 2013.12.26														*/
/* Copyright    resove														*/
/****************************************************************************/
#include <stdio.h>
#include "DrvSdSciItu.h"
#include "DrvSdCard.h"
#include "DrvSdRegister.h"
#include "DrvErrCode.h"

/****************************************************************************/
/* Ŏgp萔														*/
/****************************************************************************/

#define SD_DRV_VERSION				( 0x0002 )					/* o[W */
#define SD_DRV_TYPE					"AKI-H8 SCI.";				/* ^Cv		*/

#define CMD_LEN						(6)							/* R}h̒ */

/* SD R}h̒` */
#define CMD_GO_IDLE_STATE			(0)							/* Zbg */
#define CMD_SEND_OP_COND			(1)							/* vZXN */
#define CMD_SEND_CSD				(9)							/* CSD 擾 */
#define CMD_READ_SINGLE_BLOCK		(17)						/* READ  */
#define CMD_WRITE_BLOCK				(24)						/* WRITE  */
#define CMD_SET_BLOCKLEN			(16)						/* ubNTCYύX  */

#define DATA_TOKEN					(0xfe)						/* f[^ubÑg[N  */

/* SD response ̒`	*/
/* R1 response	*/
#define	RESPONSE_R1_MASK			(0x80)						/* R1 response ̃}XNrbg */
#define	RESPONSE_R1_IDLE			(0x01)						/* R1 response  IDLE state */

/* DATA Status response */
#define RESPONSE_DATA_MASK			(0x11)						/* DATA Response xxx1 sss1 */
#define RESPONSE_DATA_STATUS		(0x01)						/* DATA Response xxx0 sss1 Xe[^X̃CWP[^*/
#define RESPONSE_DATA_ST_MASK		(0x0e|RESPONSE_DATA_MASK)	/* DATA Response xxx1 1111 f[^X|X̃CWP[^ƃXe[^X*/
#define RESPONSE_DATA_ST_ACCEPT		(0x04|RESPONSE_DATA_STATUS)	/* DATA Response xxx0 0101 Accepted */
#define RESPONSE_DATA_ST_CRC_ERR	(0x0a|RESPONSE_DATA_STATUS)	/* DATA Response xxx0 1011 Rejected due to a CRC error */
#define RESPONSE_DATA_ST_WRITE_ERR	(0x0c|RESPONSE_DATA_STATUS)	/* DATA Response xxx0 1101 Rejected due to a Write error */

/* ^CAEg */
#define SD_RESET_TIME				( 1000UL )	/* Zbg̃^CAEg(1b)	*/
#define SD_RESET_COUNT				( SD_INITIAL_SYNC_RATE / 8UL )	/* Zbg̃^CAEgJEg	*/
#define SD_INITIALISE_COUNT			( SD_INITIALISE_TIME/SD_INITIALISE_INTERVAL )	/* ̃^CAEgJEg	*/
#define SD_INITIALISE_TIME			( 1000 )	/* ̃^CAEg(1b)	*/
#define SD_INITIALISE_INTERVAL		( 10 )		/* ̊Ԋu(10ms)		*/
#define SD_WRITE_RESPONSE_COUNT		( SD_WRITE_RESPONSE_TIME/SD_WRITE_RESPONSE_INTERVAL )	/* Write ̃^CAEgJEg	*/
#define SD_WRITE_RESPONSE_TIME		( 500 )		/* Write ̃^CAEg	*/
#define SD_WRITE_RESPONSE_INTERVAL	( 2 )		/* Write ̃X|X҂Ԋu	*/
#define SD_WAIT_WRITE_BUSY_LEN		( 8 )		/* write  BUSY ҂Mf[^ 8 oCg */
#define SD_WAIT_CMD_RESPONSE		( 8UL )		/* R}hX|X҂(8 f[^Mj*/
#define SD_WAIT_DATA_RESPONSE		( 8UL )		/* f[^X|X̃ftHg҂(8 f[^Mj*/
#define SD_WAIT_REGISTER_TOKEN		( 8UL )		/* WX^̃g[N҂(8 f[^Mj*/

/* GetR1ResponseData() ̖߂l */
/* X|XG[̓rbgʒuɒĕԂ */
#define SD_ERR_IN_IDLE_STATE		( 0x0001 )	/* 0x01 */
#define SD_ERR_ERASE_RESET			( 0x0002 )	/* 0x02 */
#define SD_ERR_ILLEGAL_COMMAND		( 0x0003 )	/* 0x04 */
#define SD_ERR_COM_CRC_ERROR		( 0x0004 )	/* 0x08 */
#define SD_ERR_ERASE_SEQ_ERROR		( 0x0005 )	/* 0x10 */
#define SD_ERR_ADDRESS_ERROR		( 0x0006 )	/* 0x20 */
#define SD_ERR_PARAMETER_ERROR		( 0x0007 )	/* 0x40 */

/* GetR1ResponseData() ̃X|XG[ȊÕG[ */
#define SD_ERR_DATA_RECEIVE_TIMEOUT	( 0x0008 )	/* f[^M^CAEg	*/
#define SD_ERR_RESPONSE_TIMEOUT		( 0x0009 )	/* X|XM^CAEg	*/
#define SD_ERR_TOKEN_RECEIVE_TIMEOUT ( 0x000a )	/* g[NM^CAEg */

/****************************************************************************/
/* ϐ																	*/
/****************************************************************************/

static T_SD_CSD csd;							/* CSD i[̈ */

static unsigned long cardSize;					/* J[hTCY			*/
static unsigned short blockSize;				/* ubNTCY		*/

static unsigned long dataResponseTimeout;		/* f[^X|X^CAEgoCg */
static unsigned long syncRate;					/* ʐM[g					*/

/****************************************************************************/
/* ֐																	*/
/****************************************************************************/
static unsigned short ResetCard( );			/* ZbgAvZXN */
static unsigned short waitForReply( unsigned char mask,
									unsigned char comp,
									unsigned long timeout );	/* X|XԂ̂҂ */
static int publishCmd( char cmd, unsigned long addr );
static unsigned short ReadAndCheckCsd();		/* CSD ̃[hƃ`FbN	*/
static unsigned short CheckCsd(  );				/* CSD ̓e`FbN	*/
static unsigned long CalcReadTimeout(  );		/* f[^X|X^CAEgvZ */
static unsigned long CalcRate( );				/* ʐM[ǧvZƍXV	*/
static unsigned short writeBlock( unsigned long address,
								 char * writeData,
								 unsigned short fill );	/* write  fill ̋ʊ֐ */
static unsigned short GetR1ResponseData( char cmd,
						unsigned long parm,
						unsigned short len,
						char * regBuff,
						unsigned long timeOut);		/* WX^ǂݍݔėp֐ */
static unsigned short BitToNum(unsigned short bit);	/* rbgʒuԂ */
static unsigned long Pow(unsigned long base, unsigned long n);	/* ׂvZ */
static unsigned long CalcBlockSize(  );					/* ubNTCYvZ */
static unsigned long CalcCardSize(  );					/* J[hTCYvZ */
static unsigned short 
	WriteSdOneBlock( unsigned long address,
					 char * writeData );				/* 1ubN */
static unsigned short
	ReadSdOneBlock( unsigned long address,
					char * readData );					/* 1ubNǂݍ */
static unsigned short
	ReadSdSmallData( unsigned long address,
						unsigned short len,
						char * readData );				/* 1ubNǂݍ */

static unsigned short changeBlockSize( void );			/* ubNTCYύX	*/

/****************************************************************************/
/* T      vFhCo												*/
/* p[^FȂ															*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        @gpn[hEFȀȂ							*/
/*          n[h́A											*/
/*           ESCI															*/
/*           E|[g														*/
/*           E^C}														*/
/*        AJ[h̃ZbgvZXN							*/
/*        BCSD ̓ǂݎ聕`FbN										*/
/****************************************************************************/
unsigned short InitSdCard( )
{
	unsigned short retCode;

	cardSize = 0UL;
	blockSize = 0;									/* ubNTCY		*/

	InitSdPort();									/* SD֘Ã|[g */
	InitSdTrans();								 	/* SD VA|[g	 */
	InitSdWait();									/* ^C} */

	retCode = ResetCard( );							/* ZbgvZX	*/
	if( retCode == SD_OK )
	{
		retCode = ReadAndCheckCsd();				/* CSD ǂݎ聕`FbN */
		if( retCode == SD_OK )
		{
			retCode = changeBlockSize( );			/* ubNTCYύX	*/
		}
	}

	return retCode;

}

/****************************************************************************/
/* T  v																	*/
/*        SDJ[hZbg											*/
/* p[^FȂ															*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         gpn[hEFȀȂ							*/
/*         n[h́A												*/
/*         ESCI															*/
/*         E|[g															*/
/*         E^C}															*/
/*         SD J[hɏR}h𑗂ăX|X҂				*/
/****************************************************************************/
unsigned short ResetCard( )
{
	unsigned int i;
	unsigned short answer = 0;
	unsigned short retCode = SD_ERR_INIT_RESET_TIMEOUT;

	SetSdOnChipsel( FALSE );						/* CS OFF */

	SendSdRepeat( '\xff', 10 );

	/* ZbgR}h */
	SetSdOnChipsel( TRUE );							/* CS ON */
	publishCmd( CMD_GO_IDLE_STATE, 0L );			/* Zbg R}h		*/
	answer = waitForReply( 0xff, RESPONSE_R1_IDLE, SD_RESET_COUNT );	/* idle state ɂȂ܂ő҂ */
	SetSdOnChipsel( FALSE );						/* CS OFF */

	/* vZXN */
	if( answer == RESPONSE_R1_IDLE )
	{
		retCode = SD_ERR_INIT_INIT_TIMEOUT;
		for( i = 0; i < SD_INITIALISE_COUNT; ++i )
		{
			SdWaitTimer( SD_INITIALISE_INTERVAL );	/* ҂			*/
			SendSdOne( '\xff' );

			SetSdOnChipsel( TRUE );					/* CS ON */
			publishCmd( CMD_SEND_OP_COND, 0L );		/* vZXN R}h	*/
			answer = waitForReply( 0xff, 0x00, SD_WAIT_CMD_RESPONSE );	/* idle state ̂҂ */
			SetSdOnChipsel( FALSE );				/* CS OFF */
			if( answer == 0x00 )
			{
				retCode = SD_OK;
				break;
			}
		}
	}
	SetSdOnChipsel( FALSE );						/* CS OFF */

	SendSdOne( '\xff' );

	return retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        Iȏ݂Ȃ										*/
/* p[^																*/
/*        addrFރJ[h̃AhX									*/
/*        buffFރf[^												*/
/*        len Fޒ												*/
/* ߂l																	*/
/*        F SD_OK														*/
/*   																	*/
/*        w肳ꂽf[^J[hɏށB								*/
/*        ݂̓ubNPʂłȂȂBJnʒuAIʒu	*/
/*       ubN̋EƍȂꍇ̓G[ƂȂB						*/
/****************************************************************************/
unsigned short WriteSdPhysical( unsigned long addr, char * buff, unsigned short len )
{
	unsigned short retCode = SD_ERR_DRV_INITIAL;

	if( ( blockSize != 0 ) && ( cardSize != 0UL ) )
	{
		retCode = SD_OK;

		/* AhX`FbN */
		if( (addr % (unsigned long)blockSize) != 0 )
		{
			retCode = SD_ERR_REQ_ADDRESS;
		}
		else if( len != blockSize )
		{
			retCode = SD_ERR_REQ_LEN;
		}
		else if( (addr + (unsigned long)len) > cardSize)
		{
			retCode = SD_ERR_REQ_ADDRESS;
		}
		else
		{
			retCode = WriteSdOneBlock( addr, buff );		/* 1 ubN */
		}
	}

	return retCode;

}

/****************************************************************************/
/* T  v																	*/
/*        IȓǂݎȂ										*/
/* p[^																*/
/*        addrFǂݎJ[h̃AhX									*/
/*        buffFǂݎf[^												*/
/*        len Fǂݎ钷												*/
/* ߂l																	*/
/*        F SD_OK														*/
/*   																	*/
/*        read ̓ubNEɍĂȂĂ悢BEɍȂf[^	*/
/*       ǂݎ̂Ădg݂ĂB										*/
/*        ubN̑傫ɖȂf[^ǂޏꍇƂPubÑf[^	*/
/*        ǂޏꍇBubN܂ǂݎ̓G[ƂB		*/
/****************************************************************************/
unsigned short ReadSdPhysical( unsigned long addr, char * buff, unsigned short len)
{
	unsigned short retCode = SD_OK;

	if( ( blockSize == 0 ) || ( cardSize == 0UL ) )
	{
		/* ̃G[ */
		retCode = SD_ERR_DRV_INITIAL;
	}
	else if( ( len == 0 ) ||
			 ( len > blockSize ) )
	{
		/*  0 or ubNTCYI[o[ */
		retCode = SD_ERR_REQ_LEN;
	}
	else if( (addr + (unsigned long)len) > cardSize)
	{
		retCode = SD_ERR_REQ_ADDRESS;								/* vAhXG[	*/
	}
	else if( ( len == blockSize ) &&
		( ( addr % (unsigned long)blockSize ) == 0UL ) )
	{
		/* ubNEubNTCY̓ǂݎ */
		retCode = ReadSdOneBlock( addr, buff );		/* 1 ubNǂݍ */
	}
	else if( ((unsigned short)(addr % (unsigned long)blockSize) + len ) > blockSize )
	{
		/* ubN܂v */
		retCode = SD_ERR_OVER_BOARDER;
	}
	else
	{
		/* ubNTCY̓ǂݎ */
		retCode = ReadSdSmallData( addr, len, buff );
	}

	return retCode;

}

/****************************************************************************/
/* T  v																	*/
/*        SDJ[hɃubN݂Ȃ								*/
/* p[^																*/
/*        address  FubNAhX										*/
/*        writeDataFރf[^ւ̃|C^								*/
/* ߂l																	*/
/*         SD_OK                  										*/
/*         SD_ERR_WRITE_TIMEOUT   ݃^CAEg						*/
/*         SD_ERR_WRITE_CRC_ERR   ݎ CRC G[						*/
/*         SD_ERR_WRITE_PHYSICAL  ݕIȃG[					*/
/*   																	*/
/****************************************************************************/
unsigned short WriteSdOneBlock( unsigned long address, char * writeData )
{
	return writeBlock( address, writeData, FALSE );
}

/****************************************************************************/
/* T  v																	*/
/*        P̃ZN^P̒lŃNA								*/
/* p[^																*/
/*        addressFubNAhX											*/
/*        writeDataFރf[^											*/
/* ߂l																	*/
/*         SD_OK                  										*/
/*         SD_ERR_WRITE_TIMEOUT   ݃^CAEg						*/
/*         SD_ERR_WRITE_CRC_ERR   ݎ CRC G[						*/
/*         SD_ERR_WRITE_PHYSICAL  ݕIȃG[					*/
/*   																	*/
/*        WriteSdOneBlock()Ɠe͂قړB								*/
/*        AFillSdOneBlock()͓f[^JԂށB			*/
/****************************************************************************/
unsigned short FillSdOneBlock( unsigned long address, char writeData )
{
	return writeBlock( address, &writeData, TRUE );
}

/****************************************************************************/
/* T  v																	*/
/*        P̃ZN^P̒lŃNA								*/
/* p[^																*/
/*        address  FubNAhX										*/
/*        writeDataFރf[^											*/
/*        fill     Ff[^ fill ̏ꍇ TRUEA						*/
/* ߂l																	*/
/*         SD_OK                  										*/
/*         SD_ERR_WRITE_TIMEOUT   ݃^CAEg						*/
/*         SD_ERR_WRITE_CRC_ERR   ݎ CRC G[						*/
/*         SD_ERR_WRITE_PHYSICAL  ݕIȃG[					*/
/*   																	*/
/*        WriteSdOneBlock()FillSdOneBlock() ŎgpB					*/
/*        Write̎菇́A													*/
/*         @R}h24𑗂												*/
/*         AR}hX|XOKH										*/
/*         B_~[TCN}												*/
/*         Cg[N𑗂													*/
/*         Df[^𑗂													*/
/*         E݃X|XOKH										*/
/*         FBUSY ҂												*/
/*              															*/
/*        f[^X|X̌`͈ȉB									*/
/*         +----+----+														*/
/*         |xxx0|sss1|  x:Dont Care.										*/
/*         +----+----+  s:Status											*/
/*              															*/
/*        0001 0001  AND ̂ 0000 0001 ƂȂĂ΃X|	*/
/*        XƂ݂ȂB														*/
/*        status ́A														*/
/*         010:Data accepted.												*/
/*         101:Data rejected due to a CRC error.							*/
/*         111:Data rejected due to a Write error.							*/
/****************************************************************************/
unsigned short writeBlock( unsigned long address, char * writeData, unsigned short fill )
{
	int i,j;
	unsigned short response;
	unsigned short sendLen = 0;
	unsigned short retCode = SD_ERR_WRITE_OTHER;
	char busyBuff[SD_WAIT_WRITE_BUSY_LEN];

	SetSdOnChipsel( TRUE );								/* CS ON */
	if( publishCmd( CMD_WRITE_BLOCK, address ) != FALSE )	/* write R}hs	*/
	{
		response = waitForReply( RESPONSE_R1_MASK, 0x00, SD_WAIT_CMD_RESPONSE );	/* R}hX|X҂ */

		if( response == 0x00 )
		{
			SendSdOne( '\xff' );
			SendSdOne( (char)DATA_TOKEN );				/* g[N	*/
			if( fill == TRUE )
			{
				sendLen = SendSdRepeat( *writeData, blockSize );	/* f[^ŃubN𖞂 */
			}
			else
			{
				sendLen = SendSdBlock( writeData, blockSize );		/* ubNf[^ */
			}
			if( sendLen == blockSize )
			{
				SendSdRepeat( '\x00', 2 );						/* CRC  */
				response = waitForReply( RESPONSE_DATA_MASK, 
											RESPONSE_DATA_STATUS,
											SD_WAIT_CMD_RESPONSE );	/* f[^X|X҂ */

				if( ( response & RESPONSE_DATA_ST_MASK )== RESPONSE_DATA_ST_ACCEPT )	/* OK	*/
				{
					/* BUSY ҂ */
					/* u҂  AIɃNbNoĂ̊Ԃ̃X|X𔻒vJԂ*/
					for( i = 0; i < SD_WRITE_RESPONSE_COUNT; ++i )
					{
						SdWaitTimer( SD_WRITE_RESPONSE_INTERVAL );		/* ҂			*/
						if( RecvSdBlock( busyBuff, '\xff', SD_WAIT_WRITE_BUSY_LEN ) != SD_WAIT_WRITE_BUSY_LEN )
						{
							retCode = SD_ERR_WRITE_RESPONSE_TIMEOUT;		/* f[^M^CAEg */
							break;
						}
						for( j = 0; j < SD_WAIT_WRITE_BUSY_LEN; ++j )
						{
							if( (busyBuff[j] & 0x0ff) == 0x0ff )
							{
								retCode = SD_OK;	
								break;
							}
						}
						if( retCode == SD_OK )
						{
							break;
						}
					}
				}
				else if( response == SD_DRV_ERR_VAL )
				{
					retCode = SD_ERR_WRITE_TIMEOUT;
				}
				else if(( response & RESPONSE_DATA_ST_MASK )== RESPONSE_DATA_ST_CRC_ERR )
				{
					retCode = SD_ERR_WRITE_CRC_ERR;
				}
				else if(( response & RESPONSE_DATA_ST_MASK )== RESPONSE_DATA_ST_WRITE_ERR )
				{
					retCode = SD_ERR_WRITE_PHYSICAL;
				}
			}
			else
			{
				retCode = SD_ERR_WRITE_TIMEOUT;
			}
		}
		else if(response == SD_DRV_ERR_VAL )
		{
			/* X|X^CAEg */
			retCode = SD_ERR_WRITE_RESPONSE_TIMEOUT;
		}
		else
		{
			/* G[X|X */
			retCode = BitToNum((unsigned short)response)+1;
			if( retCode != SD_OK ) retCode |= SD_ERR_WRITE;
		}
	}
	SetSdOnChipsel( FALSE );						/* CS OFF */
	SendSdOne( '\xff' );

	return retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        SDJ[hPubNǂݎ									*/
/* p[^																*/
/*        addressFubNAhX											*/
/*        readDataFǂݍ񂾃f[^i[̈ւ̃|C^				*/
/* ߂l																	*/
/*         SD_OK                  										*/
/*         SD_ERR_READ_TIMEOUT    ǂݍ݃^CAEg						*/
/*   																	*/
/*        read ̎菇́A													*/
/*         @R}h17𑗂												*/
/*         AR}hX|XOKH										*/
/*         Bg[N҂													*/
/*         Cf[^󂯎												*/
/****************************************************************************/
unsigned short ReadSdOneBlock( unsigned long address, char * readData )
{
	unsigned short retCode = SD_OK;

	retCode = GetR1ResponseData( CMD_READ_SINGLE_BLOCK,	/* CMD17 */
							 address,					/* 	*/
							 blockSize,					/* ubN length */
							 readData,					/* store Buffer. */
							 dataResponseTimeout );		/* X|X^CAEg */
	if( retCode != SD_OK )	retCode |= SD_ERR_READ;

	return retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        SDJ[hPubÑf[^ǂݎ						*/
/* p[^																*/
/*        address FubNAhX										*/
/*        len     Fǂݎ钷											*/
/*        readDataFǂݍ񂾃f[^i[̈ւ̃|C^				*/
/* ߂l																	*/
/*         SD_OK                  										*/
/*         SD_ERR_READ_TIMEOUT    ǂݍ݃^CAEg						*/
/*   																	*/
/*         ubN read R}h𔭍ssvȃf[^͓ǂݎ̂ĕKvȕ	*/
/*        擾B													*/
/****************************************************************************/
unsigned short ReadSdSmallData( unsigned long address, unsigned short len, char * readData )
{
	unsigned short i,ix;
	unsigned short response;
	unsigned short retCode = SD_OK;
	unsigned long blockAddr;							/* ubN̐擪AhX */
	unsigned short inBlockAddr;							/* ubN̐擪̈ʒu */

	/* ubN̐擪AhXZo */
	blockAddr = address / (unsigned long)blockSize;
	blockAddr *= (unsigned long)blockSize;				/* ubN̐擪ʒu */
	inBlockAddr = (unsigned short)(address % (unsigned long)blockSize);	/* ubN̈ʒu */

	SetSdOnChipsel( TRUE );							/* CS ON */

	if( publishCmd( CMD_READ_SINGLE_BLOCK, blockAddr ) != FALSE )					/* CMD 17 */
	{
		response = waitForReply( RESPONSE_R1_MASK, 0x00, SD_WAIT_CMD_RESPONSE );	/* R}hX|X҂ */
		if( response == 0x00 )
		{
			response = waitForReply( 0xff, DATA_TOKEN, dataResponseTimeout );	/* g[N҂ */
			if( response != SD_DRV_ERR_VAL )
			{
				ix = 0;
				for(i = 0; i < blockSize; ++i)
				{
					response = SendSdOne( '\xff' );	/* ǂݏo */
					if( ( i >= inBlockAddr) && (i < inBlockAddr+len) )
					{
						if( response != SD_DRV_ERR_VAL )
						{
							readData[ix] = (char)response;	/* Kvȃf[^ */
							++ix;
						}
						else
						{
							/* f[^^CAEg */
							retCode = SD_ERR_DATA_RECEIVE_TIMEOUT;
							break;
						}
					}
				}
				SendSdRepeat( '\xff', 2 );		/* CRC  */
			}
			else
			{
				/* g[N^CAEg */
				retCode = SD_ERR_TOKEN_RECEIVE_TIMEOUT;
			}
		}
		else if(response == SD_DRV_ERR_VAL )
		{
			/* X|X^CAEg */
			retCode = SD_ERR_RESPONSE_TIMEOUT;
		}
		else
		{
			/* G[X|X */
			retCode = BitToNum((unsigned short)response)+1;
		}
	}
	else
	{
		retCode = SD_ERR_READ_DATA_RCV_TIMEOUT;
	}

	SetSdOnChipsel( FALSE );					/* CS OFF */
	SendSdOne( '\xff' );
	if( retCode != SD_OK )	retCode |= SD_ERR_READ;

	return retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        SDJ[hCSDWX^ǂݎ									*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*         SD_OK         												*/
/*         SD_ERR_CSD_...siڍׂ̓wb_t@CQƂ̂Ɓj				*/
/*   																	*/
/*        R1 X|X`œǂݎ										*/
/****************************************************************************/
unsigned short ReadAndCheckCsd()
{
	unsigned short retCode = SD_OK;

	retCode = GetR1ResponseData( CMD_SEND_CSD,			/* CMD9 */
							 0UL,						/* 	*/
							 SD_CSD_LEN,				/* CSD length */
							 csd.byte,					/* CSD store Buffer. */
							 SD_WAIT_REGISTER_TOKEN );	/* CSD ͌Œ̑҂ԂƂ */

	if( retCode == SD_OK )	retCode = CheckCsd();	/* CSD ẽ`FbN */
	if( retCode != SD_OK)	retCode |= SD_ERR_CSD;			/* CSD G[R[hݒ	*/

	return retCode;

}
/****************************************************************************/
/* T  v																	*/
/*        ubNTCY 512 oCgɂ									*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*         SD_OK      													*/
/*         SD_ERR_... siڍׂ̓wb_t@CQƂ̂Ɓj				*/
/*   																	*/
/*         2G  SDJ[h̓ubNTCY 1024 oCgƂȂĂB	*/
/*        ABSR ̈ʒuȂǔzu̍l 512 oCg 1 ZN^Ƃč\	*/
/*        ĂB														*/
/*         ɃubNTCY 512 oCgɂB							*/
/****************************************************************************/
unsigned short changeBlockSize( void )
{
	unsigned short err = SD_ERR_CHENGE_BLOCK_SIZE;
	unsigned short response = SD_DRV_ERR_VAL;

	SetSdOnChipsel( TRUE );							/* CS ON */

	if( publishCmd( CMD_SET_BLOCKLEN, 512UL ) != FALSE )	/* ubNTCYύX		*/
	{
		response = waitForReply( RESPONSE_R1_MASK, 0x00, SD_WAIT_CMD_RESPONSE );	/* R}hX|X҂ */
	}

	SetSdOnChipsel( FALSE );						/* CS OFF */
	SendSdOne( '\xff' );

	blockSize = 512;								/* ubNTCYύX	*/
	if( response == SD_DRV_ERR_VAL )
	{
		err = SD_ERR_CHENGE_BLOCK_SIZE;
	}
	else if( response == 0x00 )
	{
		err = SD_OK;
	}
	else
	{
		err = BitToNum( response ) + 1;
	}
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        CSD ̓emF												*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*         SD_OK                  										*/
/*         SD_ERR_READ_TIMEOUT    ǂݍ݃^CAEg						*/
/*   																	*/
/****************************************************************************/
unsigned short CheckCsd(  )
{

	unsigned short retCode = SD_OK;

	dataResponseTimeout = 0L;								/* f[^^CAEgvZ		*/

	/*`FbN				*/
	if( csd.field.always1 != 1 ) retCode = SD_ERR_CSD_CHECK_BIT; /* 1ȊOG[ */

	/* nj	*/
	else
	{
		/* ɒʐM[gvZȂ΂ȂȂ */
		syncRate = CalcRate( );						/* ʐM[ǧvZƍXV	*/
		dataResponseTimeout = CalcReadTimeout( );	/* ǂݍ݃^CAEgvZ				*/

		blockSize = (unsigned short)CalcBlockSize();	/* ubNTCYvZ */
		cardSize = CalcCardSize();			/* J[hTCYvZ	*/
	}

	return  retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        ǂݍ݃^CAEgvZ									*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*         SD_OK                  										*/
/*         SD_ERR_READ_TIMEOUT    ǂݍ݃^CAEg						*/
/*   																	*/
/*         ʐM̃NbNŌvẐŐ CalcRate()ŒʐM[gvZ	*/
/*        ĂƁII													*/
/*                                                                          */
/*          TAAC+NSAC														*/
/*          TAAC exponent(TE)												*/
/*              0:1ns	4:10us												*/
/*              1:10ns	5:100us												*/
/*              2:100ns	6:1ms												*/
/*              3:1us	7:10ms												*/
/*          TAAC mantissa(TM)												*/
/*              0:~    4:1.5   8:3.5   c:5.5								*/
/*              1:1.0   5:2.0   9:4.0   d:6.0								*/
/*              2:1.2   6:2.5   a:4.5   e:7.0								*/
/*              3:1.3   7:3.0   b:5.0   f:8.0								*/
/*                                                                          */
/*          ҂ԂʐM̃oCgɒĎ							*/
/*             TE~TM(8/rate)												*/
/*             = TE~TM~rate/8												*/
/*              TE  t(TErec)ŎĂ̂ňȉ̂悤ɌvZ		*/
/*              TM~rate/(8~TErec)											*/
/*          NSAC															*/
/*              NSAC~100 NbN											*/
/*          Œl SD_WAIT_DATA_RESPONSE oCgƂB					*/
/*          ANZX^C̓f[^󂯎R}h𔭍sAf[^	*/
/*         󂯂͂߂܂ł̎ԁB											*/
/****************************************************************************/
unsigned long CalcReadTimeout(  )
{
	/* TAAC exponent Ήe[u			*/
	/* 1/(100x) ۂ̎			*/
	/* I[o[t[̂ 1/100 Ŏ	*/
	const static unsigned long TaacExpTable[] =
	{
		10000000,		/* 1ns     1GHz */
		 1000000,		/* 10ns  100MHz */
		  100000,		/* 100ns  10MHz */
		   10000,		/* 1us     1MHz */
		    1000,		/* 10us  100kHz */
		     100,		/* 100us  10kHz */
		      10,		/* 1ms     1kHz */
		       1		/* 10ms  100Hz */
	};

	/* TAAC mantissa Ήe[u	*/
	/* 10 {Ď				*/
	/* rbg[gȉׂ̂͂ĂPoCg̑҂ԂƂ	*/
	const static unsigned long TaacManTable[] =
	{
		80,		/* 0:i^CAEgőɂj */
		10,		/* 1:1.0 */
		12,		/* 2:1.2 */
		13,		/* 3:1.3 */
		15,		/* 4:1.5 */
		20,		/* 5:2.0 */
		25,		/* 6:2.5 */
		30,		/* 7:3.0 */
		35,		/* 8:3.5 */
		40,		/* 9:4.0 */
		45,		/* a:4.5 */
		50,		/* b:5.0 */
		55,		/* c:5.5 */
		60,		/* d:6.0 */
		70,		/* e:7.0 */
		80,		/* f:8.0 */
	};

	/* TAAC ő҂̒ʐMoCgvZ */
	unsigned long ratePer100;							/* [g1/100 */
	unsigned long TaacExp;								/* w */
	unsigned long TaacMan;								/*  */
	unsigned long TaacWaitByte = 1UL;

	/* TaacUnit  3 rbgȂ̂ŃG[ɂȂ悤ߔ͈̓`FbN͂ȂȂ */
	TaacExp = TaacExpTable[csd.field.taacUnit];			/* w */
	/* TaacValue  0 ͖ftHglĂ̂ł̂܂܎gp */
	/* l TaacValue 4 rbĝߔ͈̓`FbNsv */
	TaacMan = TaacManTable[csd.field.taacValue];		/*  */
	TaacWaitByte = 1;
	/*  PoCg̎Ԃ蒷ꍇvZB		*/
	/*  Zꍇ͏l̂PoCg̎ԂƂĂ		*/
	/* 													*/
	/* exp : Exponential ̋t(1/100)					*/
	/* rate: ʐM[gi8/rete = 1 oCg̒ʐM	*/
	/*    ƂTaacWaitBytevZꍇ́A		*/
	/* 1/(exp*100)  > 8/rate							*/
	/* rate         > 8*exp*100							*/
	/* rate/800     > exp								*/
	/* 													*/
	if( TaacExp < ( syncRate / 800UL  ) )
	{
		/* ʐM[g 1/100 ŌvZ */
		/* unsigned long ̍ől 4G Ȃ̂	*/
		/* [g 4G/80 𒴂ƃI[o[t[邽 */
		ratePer100 = 1;
		if( syncRate > 100UL )
		{
			ratePer100 = syncRate / 100UL;
		}
		/* TM~rate/(8~TErec) [͐؂グ		*/
		/* TM 10{ŕێĂ̂ŕ10{ */
		/* rate  1/100 Ȃ̂ŕq 1/100 Kv͂Ȃ */
		TaacWaitByte = ( TaacMan * ratePer100 + (80L * TaacExp-1))/(80L * TaacExp);
	}

	/* NSAC ő҂̒ʐMoCgvZ  */
	/* NSAC 100 NbNPʂ̃NbNȂ̂ 8 ŊĐ؂グ */
	if( csd.field.nsac != 0 )
	{
		TaacWaitByte += ((unsigned long)csd.field.nsac * 100L +7L)/8L;
	}

	/* Œlݒ肷 */
	if( TaacWaitByte < SD_WAIT_DATA_RESPONSE )
	{
		TaacWaitByte = SD_WAIT_DATA_RESPONSE;
	}

	return TaacWaitByte;
}

/****************************************************************************/
/* T  v																	*/
/*        ʐM[gvZő̃[gɕύX							*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        ʐM[g														*/
/*         G[ 0														*/
/*   																	*/
/*        J[hΉłő̒ʐM[gvZhCoK肵ő	*/
/*       ̃[gxꍇ͉\ȍő̃[gɕύXBhCoK	*/
/*       [g̕xꍇ̓hCőK肵[gɕύXB		*/
/*        ʐM[g 20Mbps ƂƂɂȂĂ邪dlł800Mbps ܂	*/
/*       Kł邱ƂɂȂĂBɌĂ܂őΉł悤ɂ	*/
/*       ĂB															*/
/*         CSD WX^̓esȏꍇ͒x[gݒ肷B			*/
/****************************************************************************/
unsigned long CalcRate( )
{
	unsigned long rate;
	unsigned long rateExp,rateMan;

	/* Rate exponent Ήe[u			*/
	/* 1/10 Ŏ						*/
	const static unsigned long rateExpTable[] =
	{
		  10000,		/* 100Kbps */
		 100000,		/* 1Mbps */
		1000000,		/* 10Mbps */
	   10000000			/* 100Mbps */
	};

	/* rate mantissa Ήe[u	*/
	/* 10 {Ď				*/
	const static unsigned long rateManTable[] =
	{
		10,		/* 0: */
		10,		/* 1:1.0 */
		12,		/* 2:1.2 */
		13,		/* 3:1.3 */
		15,		/* 4:1.5 */
		20,		/* 5:2.0 */
		25,		/* 6:2.5 */
		30,		/* 7:3.0 */
		35,		/* 8:3.5 */
		40,		/* 9:4.0 */
		45,		/* a:4.5 */
		50,		/* b:5.0 */
		55,		/* c:5.5 */
		60,		/* d:6.0 */
		70,		/* e:7.0 */
		80,		/* f:8.0 */
	};

	rateExp = rateExpTable[0];					/* ftHgŒɂĂ		*/
	if( csd.field.rateUnit <= 3 )				/* RATE ̎w 0`3 ͂nj	*/
	{
		rateExp = rateExpTable[csd.field.rateUnit];
	}

	/* rateValue 0 ͖ftHgl̂ł̂܂܎gp */
	rateMan = rateManTable[csd.field.rateValue];

	rate = rateExp * rateMan;					/* ő̒ʐM[g߂ */
	if( rate > SD_MAX_SYNC_RATE )
	{
		rate = SD_MAX_SYNC_RATE;				/* hCoK肵[g𒴂Ȃ悤ɂ */
	}

	if( ChangeSdRate( rate ) != TRUE )			/* ʐM[g̕ύX */
	{
		rate = SD_INITIAL_SYNC_RATE;			/* s͏[gɂĂ */
	}

	return rate;

}

/****************************************************************************/
/* T  v																	*/
/*        ubNTCYvZ											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*         SD_OK                  										*/
/*         SD_ERR_READ_TIMEOUT    ǂݍ݃^CAEg						*/
/*   																	*/
/*        ubNTCYvZ											*/
/*        ubNTCY 2  csd.field.blockLength B					*/
/****************************************************************************/
unsigned long CalcBlockSize(  )
{
	return Pow(2UL, (unsigned long)csd.field.blockLength);
}

/****************************************************************************/
/* T  v																	*/
/*        J[hTCYvZ											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*         SD_OK                  										*/
/*         SD_ERR_READ_TIMEOUT    ǂݍ݃^CAEg						*/
/*   																	*/
/*        J[hTCY͈ȉ̂悤ɌvZB								*/
/*																			*/
/*        [2  (cSizeMulti + 2) ] ~ [cSize + 1] ~ ubN			*/
/*																			*/
/*        ̂ߐɃubN cardInfo.blockSize Ɋi[Ă	*/
/*       ƁB																*/
/****************************************************************************/
unsigned long CalcCardSize(  )
{
	unsigned long cSize;
	unsigned long multi;

	cSize = (((unsigned long)csd.field.cSize0) << 10)|
			(((unsigned long)csd.field.cSize1) << 2) |
			( (unsigned long)csd.field.cSize2);
	cSize += 1UL;

	multi = (((unsigned long)csd.field.cSizeMult0) << 1) |
			( (unsigned long)csd.field.cSizeMult1);
	multi += 2UL;

	return Pow(2UL, multi) * cSize * (unsigned long)blockSize;	/* J[hTCYvZ */

}

/****************************************************************************/
/* T  v																	*/
/*        ZN^TCY擾											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        ubNTCY													*/
/*   																	*/
/*        ubNTCY擾BInitSdCard()sČʂ SD_OK	*/
/*       ƂȂĂ邱ƂmFB InitSdCard()sĂ鎞̌ʂ	*/
/*       ۏ؂ȂB														*/
/****************************************************************************/
unsigned short GetSdBlockSize(  )
{
	return blockSize;
}

/****************************************************************************/
/* T  v																	*/
/*        foCX̃TCY擾									*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        J[hTCY														*/
/*   																	*/
/*        J[hTCY擾BInitSdCard()sČʂ SD_OK 	*/
/*       ƂȂĂ邱ƂmFB InitSdCard()sĂ鎞̌ʂ	*/
/*       ۏ؂ȂB														*/
/****************************************************************************/
unsigned long GetSdCardSize(  )
{
	return cardSize;
}

/****************************************************************************/
/* T  v																	*/
/*        R}hs														*/
/* p[^																*/
/*        cmdFR}hCfbNX											*/
/*        addrFR}hzւ̃|C^									*/
/* ߂l																	*/
/*        TRUE = 														*/
/*        FALSE = s														*/
/*   																	*/
/****************************************************************************/
int publishCmd( char cmd, unsigned long addr )
{
	int ret = TRUE;

	char cmdWk[CMD_LEN];

	cmdWk[0] = (char)(0x40 + cmd);				/* "0x40" + (command index)" */
	cmdWk[1] = (char)(addr >> 8L*3L);
	cmdWk[2] = (char)(addr >> 8L*2L);
	cmdWk[3] = (char)(addr >> 8L*1L);
	cmdWk[4] = (char)(addr >> 8L*0L);
	cmdWk[5] = '\x95';							/* Irbg SPI [hł͎gpȂ */
	

	if( SendSdBlock( cmdWk, CMD_LEN ) != CMD_LEN )
	{
		ret = FALSE;
	}

	return ret;
}

/****************************************************************************/
/* T  v																	*/
/*        ҂														*/
/* p[^																*/
/*        maskFX|X̂Ɏgprbg}XN邽߂̒l	*/
/*        compFmask Ń}XNʂƔrl							*/
/*        timeoutFMĔr										*/
/* ߂l																	*/
/*         0 ` 0x0ff : ASD_DRV_ERR_VAL Ȃ						*/
/*   																	*/
/*        ҂B														*/
/*        Mf[^ mask Ŏw肳ꂽʒũrbgocomp 	*/
/*        rB														*/
/*        timeout ͔r̉񐔁B											*/
/****************************************************************************/
unsigned short waitForReply( unsigned char mask, unsigned char comp, unsigned long timeout )
{

	unsigned long i = 0UL;
	unsigned short answer = SD_DRV_ERR_VAL;				/* PoCgM̖߂ */
	unsigned short tempRecv = SD_DRV_ERR_VAL;				/* PoCgM̖߂ */

	for( i = 0; i < timeout; ++i )
	{
		tempRecv = SendSdOne( '\xff' );
		if( tempRecv != SD_DRV_ERR_VAL )
		{
			if( ( (char)tempRecv & mask ) == comp )
			{
				answer = tempRecv;
				break;
			}
		}
	}

	return answer;

}

/****************************************************************************/
/* T  v																	*/
/*        WX^ǂݎėp֐										*/
/* p[^																*/
/*        cmd F R}h													*/
/*        parmF														*/
/*        len FWX^f[^											*/
/*        regBuffFWX^li[̈										*/
/*        timeOutFWX^ǂݎ̃^CAEgioCgj				*/
/* ߂l																	*/
/*        TRUE     														*/
/*        FALSE    s														*/
/*   																	*/
/*        																	*/
/****************************************************************************/
unsigned short GetR1ResponseData(char cmd, unsigned long parm, unsigned short len, char * regBuff, unsigned long timeOut)
{
	unsigned short response;
	unsigned short retCode = SD_ERR_RESPONSE_TIMEOUT;

	SetSdOnChipsel( TRUE );							/* CS ON */

	if( publishCmd( cmd, parm ) != FALSE )							/* transmit CMDn */
	{
		response = waitForReply( RESPONSE_R1_MASK, 0x00, SD_WAIT_CMD_RESPONSE );	/* ҂ */

		if( response == 0x00 )
		{
			response = waitForReply( 0xff, DATA_TOKEN, timeOut );	/* g[N҂ */
			if( response == SD_DRV_ERR_VAL )
			{
				retCode = SD_ERR_TOKEN_RECEIVE_TIMEOUT;		/* g[N^CAEg */
			}
			else
			{
				if( RecvSdBlock( regBuff, '\xff', len ) != len )
				{
					retCode = SD_ERR_DATA_RECEIVE_TIMEOUT;	/* f[^M^CAEg */
				}
				else
				{
					SendSdRepeat( '\xff', 2 );		/* CRC  */
					retCode = SD_OK;						/*  */
				}
			}
		}
		else if( response == SD_DRV_ERR_VAL )
		{
			retCode = SD_ERR_RESPONSE_TIMEOUT;				/* R}hAEg */
		}
		else
		{
			retCode = BitToNum((unsigned short)response)+1;		/* G[X|X */
		}
	}

	SetSdOnChipsel( FALSE );					/* CS OFF */
	SendSdOne( '\xff' );

	return retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        ON rbg̔ԍԂ												*/
/* p[^																*/
/*        bit rbgf[^													*/
/* ߂l																	*/
/*        bit E猩Ăŏ ON Bit ̈ʒuԍŕԂB			*/
/*        E[ 0BȂꍇ 16 ԂB							*/
/*   																	*/
/*        																	*/
/****************************************************************************/
unsigned short BitToNum(unsigned short bit)
{
	unsigned short i = 0;
	unsigned short compareBit = 0x0001;
	for(i = 0; i < 16; ++i )
	{
		if( (bit & compareBit) != 0 )	break;
		compareBit <<= 1;
	}
	return i;
}

/****************************************************************************/
/* T  v																	*/
/*        ׂvZ														*/
/* p[^																*/
/*        baseF														*/
/*        n   Fw														*/
/* ߂l																	*/
/*        vZ															*/
/*   																	*/
/*        base  n vZB											*/
/****************************************************************************/
unsigned long Pow(unsigned long base, unsigned long n)
{
	unsigned long	i;
	unsigned long	answer;

	answer = 1;
	for( i = 0; i < n; i++ )
	{
		answer *= base;
	}
	return	answer;
}

/****************************************************************************/
/****************************************************************************/
/* fobOp֐															*/
/****************************************************************************/
/****************************************************************************/

/****************************************************************************/
/* T  v																	*/
/*        CSD擾														*/
/* p[^																*/
/*        csdBuffFCSD i[̈												*/
/* ߂l																	*/
/*        TRUE     														*/
/*        FALSE    s														*/
/*   																	*/
/*        																	*/
/****************************************************************************/
int GetCsd( char * csdBuff )
{
	int i = 0;

	for( i = 0; i < SD_CSD_LEN; ++i )
	{
		*(csdBuff+i) = csd.byte[i];
	}

	return TRUE;
}

/****************************************************************************/
/* T  v																	*/
/*        hCõo[W擾									*/
/* p[^																*/
/*        verFo[Wi[̈											*/
/* ߂l																	*/
/*        SD_OK o[W擾											*/
/*   																	*/
/*        o[W擾												*/
/****************************************************************************/
void GetSdDrvVer( T_RF_DRV_VER * ver )
{
	ver->ver = SD_DRV_VERSION;							/* hCoo[W */
	ver->type = SD_DRV_TYPE;							/* hCo^Cv */

}

