/****************************************************************************/
/* T  vF SD J[hgpn[hEFAɃANZXhCo			*/
/*   F SD J[h SPI [hB									*/
/*               gpĂfoCX										*/
/*               ITU0, SCI0, PB-5,6,7										*/
/*               															*/
/*               DrvSdSciTpu ͊荞݂gpNbNŒʐM	*/
/*              ȂBMׂ̊͂ă|[OŌĂĂ̊ CPU 	*/
/*              LB													*/
/*               DMA gpȂB											*/
/*               ԑ ITU0 gpĂB							*/
/*               H8/3048  SCI0  MSB t@[XgŒʐMłȂ̂ SD 	*/
/*              J[hhCoƂĂ SCI0 ƂĂB				*/
/* 쐬F 2004.09.11														*/
/* XVF 2014.02.23														*/
/* Copyright    resove														*/
/****************************************************************************/

#include	"3048F.H"
#include	"DrvSdSciItu.h"
#include	"DrvCpuXtal.h"

/* NbNŃ{[[gvZ}N			*/
/* ľܓ邽ߕ̔𕪎qɑĂB		*/
/* ..._PER4 ̓ӂ1/4BRRɐݒ肷邽߂̃}N	*/
/* l_PER8A_PER16 /8A/16 pB				*/
#define		SCI_SYNC_RATE_PHI( rate )		(unsigned short)((CPU_XTAL/4L+(unsigned long)(rate)/2L)/(unsigned long)(rate)-1L)
#define		SCI_SYNC_RATE_PHI_PER4( rate )	(unsigned short)((CPU_XTAL/16L+(unsigned long)(rate)/2L)/(unsigned long)(rate)-1L)
#define		SCI_SYNC_RATE_PHI_PER16( rate )	(unsigned short)((CPU_XTAL/64L+(unsigned long)(rate)/2L)/(unsigned long)(rate)-1L)
#define		SCI_SYNC_RATE_PHI_PER64( rate )	(unsigned short)((CPU_XTAL/256L+(unsigned long)(rate)/2L)/(unsigned long)(rate)-1L)

#define		A_BYTE_TRANS_TIME			( 1000 )		/* PoCg̑M҂[v */

/* SCMR ̒` 3048F.H ɖ̂Œ` */
union un_scmr {							/* SCMR          */
	char BYTE;							/*  Byte Access */
	struct {							/*  Bit  Access */
		unsigned char reserve1 :4;
		unsigned char SDIR     :1;		/*    SDIR      */
		unsigned char SINV     :1;		/*    SINV      */
		unsigned char reserve2 :1;
		unsigned char SMIF     :1;		/*    SMIF      */
	}
	BIT;								/*              */
};

#define SCMR    (*(volatile union un_scmr  *)0xFFFFB6) /* SCMR  Address*/

/****************************************************************************/
/* ֐																	*/
/****************************************************************************/
/* ʐM[g CSK, BRR ɐݒ肷lvZ */
static unsigned short RateToBrr( unsigned long rate );

/****************************************************************************/
/* T  v																	*/
/*        SCI													*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        VA|[g̏ȂBpower ON Ɉ񂾂ȂB	*/
/*         SD J[hƂ̒ʐMe										*/
/*          E݋֎~													*/
/*          ENbN												*/
/*          EMSB t@[Xg												*/
/****************************************************************************/
void InitSdTrans()
{
	unsigned short i;
	unsigned short cksBrr;

	cksBrr = RateToBrr( SD_INITIAL_SYNC_RATE );		/* [gݒ߂	*/

	SCI0.SCR.BIT.TE = 0;							/* M֎~ */
	SCI0.SCR.BIT.RE = 0;							/* M֎~ */
	SCMR.BIT.SDIR = 1;								/* MSB first */
	SCI0.SMR.BIT.CA		= 1; 						/* NbN */
	SCI0.SMR.BIT.CKS = (char)(cksBrr >> 8);			/* clock = ӁA/4A/16A/64 */
	SCI0.BRR = (char)cksBrr;						/* bit rate */
	for( i = 0; i < A_BYTE_TRANS_TIME; ++i);		/* wait 1bit priod */
	SCI0.SCR.BIT.TE	 = 1;							/* M */
	SCI0.SCR.BIT.RE	 = 1;							/* M */
}

/****************************************************************************/
/* T  v																	*/
/*        PoCgM												*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Mf[^													*/
/*        SD_DRV_ERR_VAL = MG[										*/
/*   																	*/
/*       MG[ SD_DRV_ERR_VAL Ԃ								*/
/****************************************************************************/
unsigned short SendSdOne( char transmitData )
{
	unsigned short receiveData = SD_DRV_ERR_VAL;	/* Mf[^ */
	unsigned short i = 0;							/* [ṽCfbNX */
	unsigned short j = 0;							/* [ṽCfbNX */

	for( i = 0; i < A_BYTE_TRANS_TIME; ++i )		/* ȎM҂ */
	{
		if( SCI0.SSR.BIT.TDRE == 1 )
		{
			/* 1oCgM */
			SCI0.TDR = (unsigned char)transmitData;	/* write transmit data */
			SCI0.SSR.BIT.TDRE = 0;					/* transmit start */
			break;
		}
	}
	if( i < A_BYTE_TRANS_TIME )
	{
		for( j = 0; j < A_BYTE_TRANS_TIME; ++j )	/* M҂	*/
		{
			if( SCI0.SSR.BIT.RDRF == 1 )
			{
				/* 1oCgM */
				receiveData = ((unsigned short)SCI0.RDR) & 0x00ff;	/* read RDR */
				SCI0.SSR.BIT.RDRF = 0;				/* clear RDR full flag */
				break;
			}
		}
	}

	return( receiveData );
}

/****************************************************************************/
/* T  v																	*/
/*        z̎MƌŒf[^̑MȂ							*/
/* p[^																*/
/*        receiveBuffFMobt@											*/
/*        transDataFMf[^												*/
/*        lenFMoCg												*/
/* ߂l																	*/
/*        MoCg													*/
/*   																	*/
/*        M͂PoCg̃f[^JԂȂBMf[^		*/
/*       receiveBuff ɂȂׂĊi[B									*/
/*        ĂяoőMƎMrāAf	*/
/*       邱ƁB															*/
/****************************************************************************/
unsigned short RecvSdBlock( char * receiveBuff, char transData, unsigned short len )
{
	unsigned short receiveData = SD_DRV_ERR_VAL;		/* Mf[^ */
	unsigned short i = 0;								/* [ṽCfbNX */

	for( i = 0; i < len; ++i )
	{
		receiveData = SendSdOne( transData );			/* MȂ */
		if( receiveData == SD_DRV_ERR_VAL )	break;
		receiveBuff[i] = (char)receiveData;		/* Mf[^obt@ɃRs[ */
	}

	return i;											/* MԂ */

}

/****************************************************************************/
/* T  v																	*/
/*        z̑MȂ												*/
/* p[^																*/
/*        transDataFMf[^												*/
/*        lenFMoCg												*/
/* ߂l																	*/
/*        M														*/
/*   																	*/
/*        w肵̃f[^AđMBMf[^͔jB*/
/*       AM񐔂͐ĂĖ߂lƂĕԂB						*/
/*        M^CAEgȂǂɂ莸sꍇ͒fB			*/
/****************************************************************************/
unsigned short SendSdBlock( char * transBuff, unsigned short len )
{
	unsigned short receiveData = SD_DRV_ERR_VAL;	/* Mf[^ */
	unsigned short i = 0;							/* [ṽCfbNX */

	for( i = 0; i < len; ++i )
	{
		receiveData = SendSdOne( transBuff[i] );	/* MȂ */
		if( receiveData == SD_DRV_ERR_VAL )	break;
	}

	return i;										/* MԂ */

}


/****************************************************************************/
/* T  v																	*/
/*        Œf[^̘AMȂ									*/
/* p[^																*/
/*        transDataFMf[^												*/
/*        lenFMoCg												*/
/* ߂l																	*/
/*        M														*/
/*   																	*/
/*        f[^w肵񐔘AđMBMf[^͔j	*/
/*       BAM񐔂͐ĂĖ߂lƂĕԂB					*/
/*        M^CAEgȂǂɂ莸sꍇ͒fB			*/
/****************************************************************************/
unsigned short SendSdRepeat( char transData, unsigned short len )
{
	unsigned short receiveWk = SD_DRV_ERR_VAL;		/* Mf[^ */
	unsigned short i = 0;							/* [ṽCfbNX */

	for( i = 0; i < len; ++i )
	{
		receiveWk = SendSdOne( transData );			/* MȂ */
		if( receiveWk == SD_DRV_ERR_VAL )	break;
	}

	return i;										/* MԂ */

}

/****************************************************************************/
/* T  v																	*/
/*        ʐM[gύX												*/
/* p[^																*/
/*        rate FʐM[g													*/
/* ߂l																	*/
/*        TRUE  FύX													*/
/*             FALSE FύXłȂ											*/
/*   																	*/
/*       w肵ʐM[gɕύX										*/
/*       M֎~ɂĂύX̌㌳ɖ߂							*/
/*       ʐMȂĂȂɎs邱ƁB							*/
/****************************************************************************/
unsigned short ChangeSdRate( unsigned long rate )
{
	unsigned short i = 0;
	unsigned short retCode = FALSE;
	unsigned short cksBrr = RateToBrr( rate );

	if( cksBrr != 0xffff )
	{
		SCI0.SMR.BIT.CKS = (unsigned char)(cksBrr >> 8);	/* clock =  */
		SCI0.BRR = (unsigned char )cksBrr;			/* bit rate */
		for( i = 0; i < A_BYTE_TRANS_TIME; ++i);	/* wait 1bit period */
		retCode = TRUE;
	}

	return retCode;

}

/****************************************************************************/
/* T  v																	*/
/*        ʐM[g BRR ɐݒ肷lvZ							*/
/* p[^																*/
/*        rate FʐM[g													*/
/* ߂l																	*/
/*        ʁFCKS ɐݒ肷l											*/
/*        ʁFBRR ɐݒ肷l											*/
/*        ݒłȂʐM[g̎ 0xffff ݒ肳B				*/
/*   																	*/
/*       ʐM[g CKS,BRR WX^ɐݒ肷lvZB			*/
/*       BRR  0 ͐ݒłȂƂƂĂ								*/
/****************************************************************************/
unsigned short RateToBrr( unsigned long rate )
{
	unsigned short retCode;
	if( ((CPU_XTAL/4UL)/2UL >= rate ) &&  ((CPU_XTAL/4UL)/256UL <= rate ) )
	{
		retCode = SCI_SYNC_RATE_PHI( rate );
	}
	else if(((CPU_XTAL/16UL)/2UL >= rate ) &&  ((CPU_XTAL/16UL)/256UL <= rate ) )
	{
		retCode = SCI_SYNC_RATE_PHI_PER4( rate ) | (unsigned short)(0x01 << 8);
	}
	else if(((CPU_XTAL/64UL)/2UL >= rate ) &&  ((CPU_XTAL/64UL)/256UL <= rate ) )
	{
		retCode = SCI_SYNC_RATE_PHI_PER16( rate ) | (unsigned short)(0x02 << 8);
	}
	else if(((CPU_XTAL/256UL)/2UL >= rate ) &&  ((CPU_XTAL/256UL)/256UL <= rate ) )
	{
		retCode = SCI_SYNC_RATE_PHI_PER64( rate ) | (unsigned short)(0x03 << 8);
	}
	else
	{
		retCode = 0xffff;
	}

	return retCode;
}

/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/* ȉԊǗ																*/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/

/* Ԃ ITU ̃JE^ɕϊ}N */
/* ̓O('L'tjƂ鎖II */
/* RgɏĂ鐔̓^C}JEgƂĐݒłC^[o}NƂĐݒł̂͐̂ */
#define ITU_COUNT_1_NS(n)	(unsigned short)((n)*( CPU_XTAL    /1000000L)/1000L-1L)	/* ns P   62.5ns<= n <  4,096S */
#define ITU_COUNT_2_NS(n)	(unsigned short)((n)*((CPU_XTAL/2L)/1000000L)/1000L-1L)	/* ns P    125ns<= n <  8,192S /2*/
#define ITU_COUNT_4_US(n)	(unsigned short)((n)*((CPU_XTAL/4L)/1000000L)-1L)		/* us P  0.25s<= n < 16,384S /4*/
#define ITU_COUNT_8_US(n)	(unsigned short)((n)*((CPU_XTAL/8L)/1000000L)-1L)		/* us P  0.5 s<= n < 32,768S /8*/

/****************************************************************************/
/* T  v																	*/
/*        ^C}̏Ȃ											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        ITU0 1ms  RyA}b`悤ɐݒ肷				*/
/****************************************************************************/
void InitSdWait()
{
	ITU0.TCR.BIT.CCLR = 1;							/* counte clear at GRA compare match */
	ITU0.TCR.BIT.CKEG = 0; 							/* count at upper edge */
	ITU0.TCR.BIT.TPSC = 3; 							/* internal clock / 8 */
	ITU0.GRA = ITU_COUNT_8_US(1000L);				/* 1 msec */

}

/****************************************************************************/
/* T  v																	*/
/*        w莞Ԃ̑҂Ȃ											*/
/* p[^																*/
/*        timeFms Pʂ̑҂											*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        GRA ̃RyA}b`̉񐔂𐔂B								*/
/*        RyA}b` 1ms Ŕ悤ɂȂĂ̂ł̉񐔂	*/
/*       ܂܎w莞ԂƂȂB												*/
/****************************************************************************/
void SdWaitTimer( short time)
{
	short i = 0;

	ITU0.TCNT = 0;								/* timer counter reset */
	ITU.TSTR.BIT.STR0 = 1; 						/* timer start */
	for( i = 0; i < time; ++i )
	{
	 	while( ITU0.TSR.BIT.IMFA == 0);			/* wait compare match	 */
	 	ITU0.TSR.BIT.IMFA = 0;					/* clear compare match flag */
	}

 	ITU.TSTR.BIT.STR0 = 0; 						/* timer stop */
}

/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/* ȉ|[gANZX														*/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/

/****************************************************************************/
/* T  v																	*/
/*        |[g̓o͂ݒ肷											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        XINSERT,XPROTECT,XCS|[g̏							*/
/****************************************************************************/
void InitSdPort()
{
	/* |[g */
	/* PB-5FXPROTECT	*/
	/* PB-6FXINSERT	*/
	/* PB-7FXCS		*/
	PB.DDR = 0x9f;		/* PB-7 o͂ɂ */
	PB.DR.BYTE = 0xff;		/* ALL ON */
	PB.DR.BIT.B7 = 0;		/* CS = 0		*/

}

/****************************************************************************/
/* T  v																	*/
/*        SD J[h̑}Ԃ擾										*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        TRUE FJ[h}Ă										*/
/*             FALSEFJ[h}ĂȂ								*/
/*   																	*/
/*        XINSERT [q͔]Ă̂ŃJ[h̑}Ԃ𔽓]ĕԂ		*/
/****************************************************************************/
short GetSdInsert()
{
	short ret = TRUE;

	if( PB.DR.BIT.B6 == 1 )
	{
		ret = FALSE;
	}

	return ret;
}

/****************************************************************************/
/* T  v																	*/
/*        SD J[h݋֎~Ԃ擾								*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        TRUE F݋֎~													*/
/*             FALSEF݋֎~ł͂Ȃ									*/
/*   																	*/
/*         XPROTECT [q͔]Ă̂ŃveNgԂ𔽓]ĕԂB	*/
/*         ɃJ[h̑}󋵂ăJ[h}ĂȂ͏݋֎~	*/
/*        ƂĂB														*/
/****************************************************************************/
short GetSdProtect()
{
	short ret = TRUE;
	if( GetSdInsert() != FALSE )
	{
		if( PB.DR.BIT.B5 == 0 )
		{
			ret = FALSE;
		}
	}

	return ret;
}

/****************************************************************************/
/* T  v																	*/
/*        SD J[h̃`bvZNg ON ɂ								*/
/* p[^																*/
/*        OnOff	TRUE F`bvZNg ON ɂ								*/
/*              FALSEF`bvZNg OFF ɂ							*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        XCS ͔]Ȃ̂ OnOff  TRUE ̎ 0 óAFALSE 1 o͂	*/
/*       B																*/
/****************************************************************************/
void SetSdOnChipsel( short OnOff )
{
	if( OnOff != FALSE )
	{
		PB.DR.BIT.B7 = 0;
	}
	else
	{
		PB.DR.BIT.B7 = 1;
	}
}

