/****************************************************************************/
/* T  vF hCoP̃eXg												*/
/*   F 																*/
/* 쐬F 2012.09.25														*/
/* XVF 2014.02.01														*/
/*              hCo̒P̃eXg										*/
/* Copyright    resove														*/
/****************************************************************************/

#include "DrvSdSciItu.h"
#include "debugFunc.h"
#include "DrvErrCode.h"
#include "DrvSdCard.h"
#include "TstGeneral.h"
#include "RfGeneral.h"
#include "TraceOut.h"
#include "TstWriteVal.h"

/* ֐^錾 */
static void ReadFunc( void );						/*  read		*/
static void WriteFunc( void );						/*  write		*/
static void FillFunc( void );						/*  fill		*/
static void ReadDetail( void );						/* ڍׂȃeXg		*/
static unsigned short compareValue( char * buff,
									 unsigned short start,
									 unsigned short len );	/* Œf[^Ɠe̔r */

/****************************************************************************/
/* T  v																	*/
/*        hCoeXg													*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         																	*/
/****************************************************************************/
void TstOrgDriver()
{
	static const T_TEST_MENU testCase[] =
	{
		{'1', "Read  Function.", 					ReadFunc},
		{'2', "Read  Detail.", 						ReadDetail},
		{'3', "Write Function.", 					WriteFunc},
		{'4', "Fill  Function.", 					FillFunc},
		{'q', "quit",			0},

	};

	static const unsigned short testCaseNum = sizeof(testCase)/sizeof(T_TEST_MENU);

	TestMenu(testCase, testCaseNum, "AkiH8(SCI):Driver test.");
}


/****************************************************************************/
/* T  v																	*/
/*        read hCo@\eXg											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         																	*/
/****************************************************************************/
void ReadFunc( void )
{
	unsigned short err;
	char buff[512];

	err = InitSdCard( );
	CHK_ERR_CODE( err, 0, "InitSdCard()" );
	err = ReadSdPhysical( 0L, buff, 512);
	CHK_ERR_CODE( err, 0, "ReadSdPhysical()" );
}

/****************************************************************************/
/* T  v																	*/
/*        read hCoڍ׃eXg											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         																	*/
/****************************************************************************/
void ReadDetail( void )
{
	unsigned short err;
	char buff[512];
	unsigned short size = 0;
	unsigned short ix;
	unsigned long cardSize;

	err = InitSdCard( );
	CHK_ERR_CODE( err, 0, "InitSdCard()" );

	err = WriteSdPhysical( 512L, constWriteVal, 512);	/*  2 ZN^ɃeXgf[^ */
	CHK_ERR_CODE( err, 0, "WriteSdPhysical()" );
	
	/* 1 ZN^ǂݍ */
	size = 0;
	ReadSdPhysical( 512L, buff, 512 );				/* read ̊Jn				*/
	ix = compareValue( buff, 0, 512);				/* Œf[^Ɠe̔r	*/
	CHK_CMP_DEC( ix, 512, "one sector." );

	/* 1 ZN^̑Oǂݍ */
	size = 0;
	ReadSdPhysical( 512L, buff, 256 );				/* read ̊Jn				*/
	ix = compareValue( buff,0, 256);				/* Œf[^Ɠe̔r	*/
	CHK_CMP_DEC( ix, 256, "first 256 bytes." );

	/* 1 ZN^̌㔼ǂݍ */
	size = 0;
	ReadSdPhysical( 512L+256L, buff, 256 );			/* read ̊Jn				*/
	ix = compareValue( buff,256, 256);				/* Œf[^Ɠe̔r	*/
	CHK_CMP_DEC( ix, 256, "after 256 bytes." );

	/* 1 ZN^̓rǂݍ */
	size = 0;
	ReadSdPhysical( 512L+100L, buff, 50);			/* read ̊Jn				*/
	ix = compareValue( buff, 100, 50);				/* Œf[^Ɠe̔r	*/
	CHK_CMP_DEC( ix, 50, "middle 50 bytes." );
	
	/* ubNEI[o[ */
	size = 0;
	err = ReadSdPhysical( 512L+500L, buff, 50);		/* read ̊Jn				*/
	CHK_ERR_CODE( err, SD_ERR_OVER_BOARDER, "ReadSdPhysical() over boarder." );

	/* ubNTCY */
	size = 0;
	err = ReadSdPhysical( 512L, buff, 1024);		/* read ̊Jn				*/
	CHK_ERR_CODE( err, SD_ERR_REQ_LEN, "ReadSdPhysical() over size." );

	/* J[hŜ̃TCY𒴂v */
	cardSize = GetSdCardSize();
	err = ReadSdPhysical( cardSize, buff, 10);		/* read ̊Jn				*/
	CHK_ERR_CODE( err, SD_ERR_REQ_ADDRESS, "ReadSdPhysical() over capacity." );
}

/****************************************************************************/
/* T  v																	*/
/*        Œf[^Ɠer										*/
/* p[^																*/
/*        buff FrΏۂ̃f[^̈										*/
/*        startFrJnʒu												*/
/*        len  Fr钷												*/
/* ߂l																	*/
/*        ꂾBׂēȏꍇ len ƓlBقȂꍇ		*/
/*       قȂʒuƂȂB												*/
/*   																	*/
/*         																	*/
/****************************************************************************/
unsigned short compareValue( char * buff, unsigned short start, unsigned short len )
{
	unsigned short i;

	for( i = 0; i < len; i++ )
	{
		if( buff[i] != constWriteVal[start+i] )
		{
			break;
		}
	}

	return i;
}

/****************************************************************************/
/* T  v																	*/
/*        write hCo@\eXg											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         																	*/
/****************************************************************************/
void WriteFunc( void )
{
	unsigned short err;
	unsigned short size = 0;
	char buff[512];
	unsigned short ix;

	err = InitSdCard( );
	CHK_ERR_CODE( err, 0, "InitSdCard()" );
	err = WriteSdPhysical( 512L, constWriteVal, 512);
	CHK_ERR_CODE( err, 0, "WriteSdPhysical()" );

	/* verify */
	err = ReadSdPhysical( 512L, buff, 512);			/* 񓯊 read ̊Jn		*/
	CHK_ERR_CODE( err, 0, "ReadSdPhysical()" );
	ix = compareValue( buff, 0, 512);				/* Œf[^Ɠe̔r	*/
	CHK_CMP_DEC( ix, 512, "verify read." );
}

/****************************************************************************/
/* T  v																	*/
/*        fill hCo@\eXg											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         																	*/
/****************************************************************************/
void FillFunc( void )
{
	unsigned short err;
	unsigned short size = 0;
	char buff[512];
	unsigned short ix;

	err = InitSdCard( );
	CHK_ERR_CODE( err, 0, "InitSdCard()" );
	err = FillSdOneBlock( 512L, 0xff);
	CHK_ERR_CODE( err, 0, "FillSdOneBlock()" );

	/* verify */
	err = ReadSdPhysical( 512L, buff, 512);			/* 񓯊 read ̊Jn		*/
	CHK_ERR_CODE( err, 0, "ReadSdPhysical()" );
	for( ix = 0; ix < 512; ix++ )
	{
		if( (unsigned char)buff[ix] != 0xff)
		{
			break;
		}
	}
	CHK_CMP_DEC( ix, 512, "verify read." );
}

