/****************************************************************************/
/* T  vF mFp{s											*/
/*   F 																*/
/* 쐬F 2011.09.08														*/
/* XVF 2011.09.23														*/
/*              InitialConfirm ɃX^bNgpʕ\				*/
/* Copyright    resove														*/
/****************************************************************************/

#include "RfInterface.h"
#include "debugFunc.h"
#include "TstGeneral.h"
#include "RfGeneral.h"
#include "TraceOut.h"

static char * freeSp1;
static char * freeSp2;

/* ֐^錾 */
static void writeConfirm( void );
static void readConfirm( void );
static void writeCardInfo( void );
static void execConclude( void );

#define CONFIRM_FLNAME	"\\INITIAL.TXT"
#define CONFIRM_VAL		"0123456789"
#define CONFIRM_LEN		((unsigned long)(sizeof(CONFIRM_VAL)-1))

/* ϐ */
static char readBuff[CONFIRM_LEN];

/****************************************************************************/
/* T  v																	*/
/*        mF															*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         																	*/
/****************************************************************************/
void TstOrgInitialConfirm()
{
	TestReady();

	writeConfirm();
	readConfirm();
	writeCardInfo();
	execConclude();

	TestConclude( );
}

/****************************************************************************/
/* T  v																	*/
/*        mF														*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         																	*/
/****************************************************************************/
void writeConfirm( void )
{
	T_RF_FCB * pFcb;
	unsigned short err;
	unsigned long len;

	fillSp();
	freeSp1 = checkFreeSp();
	pFcb = RfOpen( CONFIRM_FLNAME, RF_OPEN_WRITE_NEW, &err );
	freeSp2 = checkFreeSp();
	TRACE_OUT(("    Calculate StackSize. RfOpen 0x%08lx -> 0x%08lx(%ld)\n", freeSp1,
											 freeSp2,
											 (unsigned long)freeSp1 - (unsigned long)freeSp2));
	if( pFcb )
	{
		len = CONFIRM_LEN;
		fillSp();
		freeSp1 = checkFreeSp();
		err = RfWrite( pFcb, CONFIRM_VAL, &len);
		freeSp2 = checkFreeSp();
		TRACE_OUT(("    Calculate StackSize. RfWrite 0x%08lx -> 0x%08lx(%ld)\n", freeSp1,
											 freeSp2,
											 (unsigned long)freeSp1 - (unsigned long)freeSp2));
		fillSp();
		freeSp1 = checkFreeSp();
		err = RfClose( pFcb );
		freeSp2 = checkFreeSp();
		TRACE_OUT(("    Calculate StackSize. RfClose 0x%08lx -> 0x%08lx(%ld)\n", freeSp1,
											 freeSp2,
											 (unsigned long)freeSp1 - (unsigned long)freeSp2));
	}
}

/****************************************************************************/
/* T  v																	*/
/*        mFǂݎ														*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         																	*/
/****************************************************************************/
void readConfirm( void )
{
	T_RF_FCB * pFcb;
	unsigned short err;
	unsigned long len;

	pFcb = RfOpen( CONFIRM_FLNAME, RF_OPEN_READ, &err );
	if( pFcb )
	{
		len = CONFIRM_LEN;
		err = RfRead( pFcb, readBuff, &len);
		err = RfClose( pFcb );
	}
}

/****************************************************************************/
/* T  v																	*/
/*        J[ho													*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         																	*/
/****************************************************************************/
void writeCardInfo( void )
{
	T_RF_FCB * pFcb;
	unsigned short err;
	unsigned long len;
	char writeBuff[32];
	short readResult;

	T_RF_DRIVE_INFO driveInfo;

	err = RfGetDriveInfo( &driveInfo );

	pFcb = RfOpen( "\\CARDINFO.TXT", RF_OPEN_WRITE_NEW, &err );

	if( pFcb )
	{
		/* read ̌ʏo */
		len = 11UL;
		RfWrite( pFcb, "read value:", &len);
		len = CONFIRM_LEN;
		RfWrite( pFcb, readBuff, &len);
		readResult = rfMemCmp(readBuff, CONFIRM_VAL, CONFIRM_LEN);
		if( readResult == 0 )
		{
			len = 14UL;
			RfWrite( pFcb, "\nread OK(^_^)\n",&len);
		}
		else
		{
			len = 16UL;
			RfWrite( pFcb, "\nread FAIL(-_-)\n",&len);
		}

		/* foCXo */
		if( err != RF_OK )
		{
			len = 4UL;
			RfWrite( pFcb, "err(", &len );
			hexToChar(writeBuff, err );
			len = 4UL;
			RfWrite( pFcb, writeBuff, &len);
			len = 2UL;
			RfWrite( pFcb, ")\n", &len );
		}
		else
		{
			len = 9UL;
			RfWrite( pFcb, "capacity(", &len );
			len = (unsigned long)numToChar( writeBuff, driveInfo.cardSize, 10L);
			RfWrite( pFcb, writeBuff, &len );
			len = 2UL;
			RfWrite( pFcb, ")\n", &len );


			len = 13UL;
			RfWrite( pFcb, "cluster size(", &len );
			len = (unsigned long)numToChar( writeBuff, driveInfo.bytesPerCluster, 10L);
			RfWrite( pFcb, writeBuff, &len );
			len = 2UL;
				RfWrite( pFcb, ")\n", &len );

			len = 15UL;
			RfWrite( pFcb, "sector/cluster(", &len );
			len = (unsigned long)numToChar( writeBuff, (unsigned long)driveInfo.sectorPerCluster, 10L);
			RfWrite( pFcb, writeBuff, &len );
			len = 2UL;
			RfWrite( pFcb, ")\n", &len );	

			if( driveInfo.fSystem == RF_F_SYSTEM_FAT12 )
			{
				len = 6UL;
				RfWrite( pFcb, "FAT12\n", &len);
			}
			else if(driveInfo.fSystem == RF_F_SYSTEM_FAT16 )
			{
				len = 6UL;
				RfWrite( pFcb, "FAT16\n", &len);
			}
			else
			{
				len = 21UL;
				RfWrite( pFcb, "unknown file system.\n",&len);
			}
		}
		RfClose( pFcb );
	}
}

/****************************************************************************/
/* T  v																	*/
/*        t@CVXeI												*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         																	*/
/****************************************************************************/
void execConclude( void )
{
	unsigned short err;

	err = RfConclude( );
}
