/****************************************************************************/
/* T  vF t@CVXẽptH[}XeXg							*/
/*   F 																*/
/* 쐬F 2011.10.30														*/
/* XVF 2014.02.23														*/
/* Copyright    resove														*/
/****************************************************************************/

#include "DrvSdSciItu.h"
#include "DebugFunc.h"
#include "DrvErrCode.h"
#include "TstGeneral.h"
#include "TstDefine.h"
#include "RfInterface.h"
#include "RfGeneral.h"
#include "TraceOut.h"
#include "TstWriteVal.h"

#define TARGET_NAME "\\64k.txt"
#define WRITE_FILE_NAME "\\w64k.txt"
#define WRITE_VAL_BLOCK_LEN		(4096L)

/* ֐^錾 */
static void ReadSync( void );										/* ǂݎ	*/

static void readTimeHistGram( unsigned long time, unsigned long ix );	/* qXgO */
static void MakeTestData( void );									/* eXgf[^쐬	*/
static void clearHistGram( void );									/* qXgOf[^̏ */
static void dispHistGram( void );									/* qXgO\ */
static void ReadFunc( unsigned short option, short wait );	/* read ʋ@\	*/

static void WriteNewSync0( void );									/* VKwrite	*/
static void WriteOldSync0( void );									/* write	*/
static void WriteFunc( unsigned short option, short wait );			/* write ʋ@\	*/

static void dispCaseName( char * caseName );						/* eXgP[X\	*/

/* ϐ */
static unsigned short histLevel[10];
static unsigned short histIx[10];
static unsigned long max = 0L;
static unsigned long min = 0L;
static unsigned long maxIx = 0L;
static unsigned long minIx = 0L;

/****************************************************************************/
/* T  v																	*/
/*        \eXg														*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void TstOrgPerformance()
{
	static const T_TEST_MENU testCase[] =
	{
		{'1', "Ready.", 				TestReady},
		{'2', "Make TestData.", 		MakeTestData},
		{'3', "Read synchronous. ", 	ReadSync},
		{'4', "Write New. ", 			WriteNewSync0},
		{'5', "Write Old.", 			WriteOldSync0},
		{'q', "quit",			0},

	};

	static const unsigned short testCaseNum = sizeof(testCase)/sizeof(T_TEST_MENU);

	TestMenu(testCase, testCaseNum, "AkiH8(SCI):Performance test.");
}

/****************************************************************************/
/* T  v																	*/
/*        eXgf[^쐬													*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void MakeTestData( void )
{
	T_RF_FCB * pFcb;
	unsigned short err;
	unsigned long len = WRITE_VAL_BLOCK_LEN;
	unsigned short i;

	err = RfInitFileSystem( );
	CHK_ERR_CODE(err, RF_OK, "RfInitFileSystem()");
	pFcb = RfOpen( TARGET_NAME, RF_OPEN_WRITE_NEW, &err );
	CHK_ERR_CODE(err, RF_OK, "RfOpen(RF_OPEN_WRITE_NEW)");


	if( pFcb )
	{
		for( i = 0; i < 65536L/WRITE_VAL_BLOCK_LEN; i++ )
		{
			len = WRITE_VAL_BLOCK_LEN;
			err = RfWrite( pFcb, (char*)constWriteVal, &len);
			CHK_ERR_CODE(err, RF_OK, "RfWrite()");
		}
		err = RfClose( pFcb );
		CHK_ERR_CODE(err, RF_OK, "RfClose()");
	}
	
}

/****************************************************************************/
/* T  v																	*/
/*         read \eXg												*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void ReadSync( void )
{
	dispCaseName( "Read synchronous. (0 wait)" );
	ReadFunc( RF_OPEN_READ, 0 );
}

/****************************************************************************/
/* T  v																	*/
/*        read ʋ@\														*/
/* p[^																*/
/*        optionFopen ̃IvV											*/
/*        wait  Fread Ԃ̑҂											*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void ReadFunc( unsigned short option, short wait )
{
	T_RF_FCB * pFcb;
	unsigned short err;
	char buff[2];
	unsigned long i;
	unsigned long size;
	unsigned long takeLen;
	
	clearHistGram( );
	err = RfInitFileSystem( );
	CHK_ERR_CODE(err, RF_OK, "RfInitFileSystem()");


	pFcb = RfOpen( TARGET_NAME, option, &err );
	CHK_ERR_CODE( err, RF_OK, "RfOpen()" );
	err = RfGetSize( pFcb, &size );
	CHK_ERR_CODE( err, RF_OK, "RfGetSize()" );
	TRACE_OUT((" file size = %ld\n", size));

	for(i = 0; i < size; i += 2 )
	{


		takeLen = 2;

		StartTimeCount();
		err = RfRead(pFcb, buff, &takeLen);
		StopTimeCount();
		readTimeHistGram( GetTimeCount(NULL), i );	/* Ԏ擾		*/
		if( err != RF_OK )
		{
			CHK_ERR_CODE( err, RF_OK, "RfRead() error." );
			break;
		}
		if( takeLen != 2 )
		{
			CHK_CMP_DEC(takeLen, 2, "RfRead() size error.")
			break;
		}
		if( ( buff[0] != constWriteVal[i%WRITE_VAL_BLOCK_LEN] ) ||
			( buff[1] != constWriteVal[(i+1)%WRITE_VAL_BLOCK_LEN] ) )
		{
			CHK_CMP_HEX(buff[0], constWriteVal[(i+0)%WRITE_VAL_BLOCK_LEN], "RfRead() value errro.")
			CHK_CMP_HEX(buff[1], constWriteVal[(i+1)%WRITE_VAL_BLOCK_LEN], "RfRead() value error.")
			break;
		}
		if( ( ((unsigned long)(wait==0L?1L:wait*2L) * i ) % 10000L) == 0 )
		{
			TRACE_OUT((" complete size = %5ld\n", i));
		}
		if( wait != 0 )
		{
			SdWaitTimer( wait );
		}
	}

	err = RfClose( pFcb );
	CHK_ERR_CODE( err, RF_OK, "RfClose()" );
	dispHistGram();
}


/****************************************************************************/
/* T  v																	*/
/*        VK write \eXg												*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void WriteNewSync0( void )
{
	unsigned short err;

	dispCaseName( "Write New.sync. (0ms wait)" );
	err = RfInitFileSystem( );
	CHK_ERR_CODE(err, RF_OK, "RfInitFileSystem()");

	RfDelFile( WRITE_FILE_NAME );					/* o̓t@CAĂsĂǂł悢 */
	WriteFunc( RF_OPEN_WRITE_NEW, 0 );
}

/****************************************************************************/
/* T  v																	*/
/*        ㏑ write \eXg											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void WriteOldSync0( void )
{
	unsigned short err;

	dispCaseName( "Write Old.sync. (0ms wait)" );
	err = RfInitFileSystem( );
	CHK_ERR_CODE(err, RF_OK, "RfInitFileSystem()");

	RfDelFile( WRITE_FILE_NAME );					/* o̓t@CAĂsĂǂł悢 */

	WriteFunc( RF_OPEN_WRITE_NEW, 0 );				/* VK write  */
	WriteFunc( RF_OPEN_WRITE_OLD, 0 );				/* t@Cւ write */
}

/****************************************************************************/
/* T  v																	*/
/*        write ʋ@\													*/
/* p[^																*/
/*        optionFopen ̃IvV											*/
/*        wait  Fwrite Ԃ̑҂										*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void WriteFunc( unsigned short option, short wait )
{
	T_RF_FCB * pFcb;
	unsigned short err;
	char buff[2];
	unsigned long i;
	unsigned long size = 0x10000;
	unsigned long writeLen;
	unsigned long takeLen;

	clearHistGram( );



	pFcb = RfOpen( WRITE_FILE_NAME, option, &err );
	CHK_ERR_CODE( err, RF_OK, "RfOpen()" );

	for(i = 0L; i < size; i += 2 )
	{

		/* ݃f[^ */
		writeLen = 2;
		buff[0] = constWriteVal[i%WRITE_VAL_BLOCK_LEN];
		buff[1] = constWriteVal[(i+1)%WRITE_VAL_BLOCK_LEN];

		/*  */
		StartTimeCount();
		err = RfWrite(pFcb, buff, &writeLen);
		StopTimeCount();

		readTimeHistGram( GetTimeCount(NULL), i );	/* Ԏ擾		*/

		/* G[`FbN */
		if( err != RF_OK )
		{
			CHK_ERR_CODE( err, RF_OK, "RfWrite() error." );
			break;
		}
		if( writeLen != 2 )
		{
			CHK_CMP_DEC(writeLen, 2, "RfWrite() size error.")
			break;
		}
		if( ( ((unsigned long)(wait==0L?1L:wait*2L) * i ) % 10000L) == 0 )
		{
			TRACE_OUT((" complete size = %5ld\n", i));
		}
		if( wait != 0 )
		{
			SdWaitTimer( wait );
		}
	}

	TRACE_OUT((" complete size = %5ld\n", i));
	err = RfClose( pFcb );
	CHK_ERR_CODE( err, RF_OK, "RfClose()" );
	dispHistGram();

	/* emF */
	pFcb = RfOpen(WRITE_FILE_NAME, RF_OPEN_READ|RF_OPEN_OPT_SEQ, &err );
	CHK_ERR_CODE( err, RF_OK, "RfOpen()" );
	for( i = 0L; i < size; i += 2) 
	{
		takeLen = 2L;
		err = RfRead(pFcb, buff, &takeLen);
		if( ( buff[0] != constWriteVal[i%WRITE_VAL_BLOCK_LEN] ) ||
			( buff[1] != constWriteVal[(i+1)%WRITE_VAL_BLOCK_LEN] ) )
		{
			CHK_CMP_HEX(buff[0], constWriteVal[(i+0)%WRITE_VAL_BLOCK_LEN], "RfRead() value errro.")
			CHK_CMP_HEX(buff[1], constWriteVal[(i+1)%WRITE_VAL_BLOCK_LEN], "RfRead() value error.")
			break;
		}
		if( (i % 10000L) == 0 )
		{
			TRACE_OUT((" verify size = %5ld\n", i));
		}
	}
	TRACE_OUT((" verify size = %5ld\n", i));
	err = RfClose( pFcb );
	CHK_ERR_CODE( err, RF_OK, "RfClose()" );
}

/****************************************************************************/
/* T  v																	*/
/*        qXgO													*/
/* p[^																*/
/*        time F 10us Pʂ̎											*/
/*        ix   F ǂݎf[^ʒu										*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void readTimeHistGram( unsigned long time, unsigned long ix )
{
	unsigned short level = 0;

	if( time > 16000L )			/* 16msȏ */
	{
		level = 7;
	}
	else if( time > 8000L )		/* 8msȏ */
	{
		level = 6;
	}
	else if( time > 4000L )		/* 4msȏ */
	{
		level = 5;
	}
	else if( time > 2000L )		/* 2msȏ */
	{
		level = 4;
	}
	else if( time > 1000L )		/* 1msȏ */
	{
		level = 3;
	}
	else if( time > 500L )	/* 500us ȏ */
	{
		level = 2;
	}
	else if( time > 250L )	/* 250us ȏ */
	{
		level = 1;
	}
	else
	{
		level = 0;
	}

	histLevel[level]++;
	histIx[level] = (unsigned short)ix;
	if( (max == 0L) && (min == 0L ) )
	{
		max = time;
		min = time;
		maxIx = ix;
		minIx = ix;
	}
	if( max < time )
	{
		max = time;
		maxIx = ix;
	}
	if( min > time )
	{
		min = time;
		minIx = ix;
	}
}

/****************************************************************************/
/* T  v																	*/
/*        qXgOf[^̏											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void clearHistGram( void )
{
	unsigned short i;

	for( i = 0; i < 10; i++ )
	{
		histLevel[i] = 0;
		histIx[i] = 0;
	}

	max = 0L;
	min = 0L;
	maxIx = 0L;
	minIx = 0L;
	InitTimeCount();		/* ^C}̏ */

}

/****************************************************************************/
/* T  v																	*/
/*        qXgO\											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void dispHistGram( void )
{
	unsigned short i;

	traceOut("hist gram 0-250us,-500us, -1ms,  -2ms,  -4ms,  -8ms, -16ms, 16ms-\n");
	/*                    xxxxx..xxxxx..xxxxx..xxxxx..xxxxx..xxxxx..xxxxx..xxxxx */
	traceOut("count       ");
	for( i = 0; i < 8; i++ )
	{
		traceOut("%4u   ",histLevel[i]);
	}
	traceOut("\n");
	traceOut("ix          ");
	for( i = 0; i < 8; i++ )
	{
		traceOut("%5u  ",histIx[i]);
	}
	traceOut("\n");
	traceOut("max(%lu)[%lu] min(%lu)[%lu]\n", max, maxIx, min, minIx);
}

/****************************************************************************/
/* T  v																	*/
/*        eXgP[X\											*/
/* p[^																*/
/*        caseNameFeXgP[X\									*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void dispCaseName( char * caseName )
{
	TRACE_OUT(("\n"));
	TRACE_OUT(("=====================================\n"));
	TRACE_OUT(("%s\n",caseName));
}
