/****************************************************************************/
/* T  vF hCũCAEg											*/
/*   F MBRABPBAfBNg̃CAEg								*/
/* 쐬F 2005.02.12														*/
/* XVF 2009.01.04														*/
/* Copyright F	resove														*/
/****************************************************************************/
#ifndef RF_DRIVE_LAYOUT_H
#define RF_DRIVE_LAYOUT_H

#define	RF_SIGNATURE_VALUE		( 0xaa55 )				/* MBRABPB SIGNATURE ̓e */

/********************************************************/
/* MBR ̈ʒu											*/
/********************************************************/
#define MBR_PARTITION_TABLE		( 446 )
#define MBR_SIGNATURE			( 510 )					/* 2 MBR ̎ʎq 0xAA55 	*/

#define MBR_BPB_SECTOR_POINT	( MBR_PARTITION_TABLE + MBR_PT_BPB_POINT )		/* 4 BPB ̃ZN^ʒu( 0x1c6 )	*/

/* Partition Table Field ̈ʒu	*/
#define	MBR_PT_BOOT_INDICATOR		(  0 )					/* 1 Np[eBV敪 */
#define	MBR_PT_START_POINT			(  1 )					/* 3 Jnʒuihead:8AsectorF6AcylinderF10) */
#define MBR_PT_SYSTEM_ID			(  4 )					/* 1 SYSTEM ID.	*/
#define MBR_PT_END_POINT			(  5 )					/* 3 Iʒuihead:8AsectorF6AcylinderF10) */
#define MBR_PT_BPB_POINT			(  8 )					/* 4 ZN^擪ʒu */
#define MBR_PT_SECTOR_IN_PERTITION	( 12 )					/* 4 ZN^		*/
#define MBR_PT_SIZE					( 16 )					/* p[eBVe[ũTCY	*/

/* MBR_PT_SYSTEM_ID ̓e */
/* 0x01 FAT12 primary partition or logical drive (fewer than 32,680 sectors in the volume) 	*/
/* 0x04 FAT16 partition or logical drive (32,680-65,535 sectors or 16 MB-33 MB) 			*/
/* 0x05 Extended partition 																	*/
/* 0x06 BIGDOS FAT16 partition or logical drive (33 MB-4 GB)  								*/
/* 0x07 Installable File System (NTFS partition or logical drive) 							*/
/* 0x0B FAT32 partition or logical drive 													*/
/* 0x0C FAT32 partition or logical drive using BIOS INT 13h extensions 						*/
/* 0x0E BIGDOS FAT16 partition or logical drive using BIOS INT 13h extensions 				*/
/* 0x0F Extended partition using BIOS INT 13h extensions 									*/
/* 0x12 EISA partition 																		*/
/* 0x42 Dynamic disk volume 																*/
/* 0x86 Legacy FT FAT16 disk * 																*/
/* 0x87 Legacy FT NTFS disk * 																*/
/* 0x8B Legacy FT volume formatted with FAT32 *									 			*/
/* 0x8C Legacy FT volume using BIOS INT 13h extensions formatted with FAT32 * 				*/

#define MBR_SYSTEM_ID_FAT12			( 0x01 )
#define MBR_SYSTEM_ID_FAT16			( 0x04 )
#define MBR_SYSTEM_ID_FAT16_BIG		( 0x06 )

/********************************************************/
/* BPB ̈ʒu											*/
/********************************************************/

#define BPB_JUMP_INSTRUCTION	( 0 )					/* 3 JMP 				*/
#define BPB_OEM_ID				( 3 )					/* 8 format VXe	*/

/* BPB */
#define BPB_BYTES_PER_SECTOR	( 11 )					/* 1 1ZN^̃oCg			*/
#define BPB_SECTOR_PER_CLUSTER	( 13 )					/* 1 PNX^̃ZN^	*/
#define BPB_RSVD_SEC_CNT		( 14 )					/* 2 \ZN^	*/
#define BPB_NUM_OF_FAT			( 16 )					/* 1 FAT 	*/
#define BPB_NUM_OF_ROOT			( 17 )					/* 2 ROOT DIRECTORY Gg	*/
#define BPB_TOTAL_SECT			( 19 )					/* 2 ZN^	*/
#define BPB_MEDIA_DESCRIPTOR	( 21 )					/* 1 fBAʎq			*/
#define BPB_SECTOR_PER_FAT		( 22 )					/* 2 PFAT ̃ZN^	*/
#define BPB_SECTOR_PER_TRUCK	( 24 )					/* 2 PgbÑZN^	*/
#define BPB_NUMBER_OF_HEAD		( 26 )					/* 2 wbh					*/
#define BPB_HIDDEN_SECT			( 28 )					/* 4 BꂽZN^			*/
#define BPB_LARGE_TOTAL_SECT	( 32 )					/* 4 eʃfBXN̑ZN^	*/

/* gBPB */
#define BPB_PHYSICAL_DRIVE_NUM	( 36 )					/* 1 	*/
#define BPB_EXT_BOOT_SIGNATURE	( 38 )					/* 1 0x28,0x29 win2000ʂ鎯ʎq		*/
#define BPB_VOLUME_SERIAL_NO	( 39 )					/* 4 fBXN̂郉_Ȕԍ	*/
#define BPB_VOLUME_LABEL		( 43 )					/* 11 "NO NAME    "			*/
#define BPB_FILE_SYSTEM_TYPE	( 54 )					/* 8 "FAT12   "/"FAT16   "	*/

#define BPB_SIGNATURE			( 510 )					/* 2 BPB ̎ʎq \x55 \xAA (0xAA55)	*/

/********************************************************/
/* BPB ̈ʒu											*/
/********************************************************/

/********************************************************/
/* fBNgtH[}bg								*/
/********************************************************/
#define DIR_NAME				( 0 )					/* 8 t@C				*/
#define DIR_NAME_EXT			( 8 )					/* 3 gq					*/
#define DIR_ATTRIBUTE			( 11 )					/* 1 					*/
#define DIR_NAME_CHAR			( 12 )					/* 1 t@C̕	*/
#define DIR_CRT_TIME_TENTH		( 13 )					/* 1 쐬 10ms P	*/
#define DIR_CREATE_TIME			( 14 )					/* 2 쐬				*/
#define DIR_CREATE_DATE			( 16 )					/* 2 쐬t				*/
#define DIR_ACCESS_DATE			( 18 )					/* 2 ŏIANZXt		*/
#define DIR_CLUSTOR_HI_NUM		( 20 )					/* 2 擪NX^ԍiFAT32j	*/
#define DIR_UPDATE_TIME			( 22 )					/* 2 XV				*/
#define DIR_UPDATE_DATE			( 24 )					/* 2 XVt				*/
#define DIR_CLUSTOR_NUM			( 26 )					/* 2 擪NX^ԍ		*/
#define DIR_FILE_SIZE			( 28 )					/* 4 t@CTCY			*/

#define DIR_RECORD_SIZE			( 32 )					/* fBNg̃R[hTCY		*/

#define DIR_CLUSTOR_NUM_LEN		( 2 )					/* NX^ԍ̒			*/

/* ^(DIR_NAME_CHAR)̓e */
/* gqA^Cgꂼꂪׂďō\Ă鎞ȉ̃rbg */
#define DIR_NAME_TITLE_SMALL	( 0x08 )				/* ^Cg				*/
#define DIR_NAME_EXTENT_SMALL	( 0x10 )				/* gq					*/

/* Ot@C̒ */
#define DIR_LONG_FLNAME			( 255 )					/* Ot@C̒		*/

/* V[gt@C̒\ */
#define DIR_SHORT_FLNAME_BODY	( 8 )					/* t@C{				*/
#define DIR_SHORT_FLNAME_EXT	( 3 )					/* gq					*/
#define DIR_SHORT_FLNAME_TOTAL	(DIR_SHORT_FLNAME_BODY+DIR_SHORT_FLNAME_EXT)

/* [gfBNgGg */
#define DIR_ROOT_ENTRY_NUM		( 512 )
#define DIR_ROOT_BYTE_NUM		( DIR_ROOT_ENTRY_NUM * DIR_RECORD_SIZE)	/* [g̃oCg	*/

/* V[gt@C̋敪 */
#define DIR_NAME_FREE_ENTRY1	( (char)0xe5 )			/* 폜fBNgGg[		*/
#define DIR_NAME_FREE_ENTRY2	( (char)0x05 )			/* 폜fBNgGg[({̂݁j	*/
#define DIR_NAME_UNUSED_ENTRY	( (char)0x00 )			/* gp̃fBNgGg[		*/
#define DIR_NAME_EXCEPTION		( '.' )					/* pr̃fBNgGg[	*/

/* ATTRIBUTE ̓e */
#define DIR_ATTR_READ_ONLY   	( (unsigned char)0x01 )	/* ǂݎp					*/
#define DIR_ATTR_HIDDEN			( (unsigned char)0x02 )	/* Bt@C					*/
#define DIR_ATTR_SYSTEM			( (unsigned char)0x04 )	/* VXet@C				*/
#define DIR_ATTR_VOLUME_ID	 	( (unsigned char)0x08 )	/* {[ ID				*/
#define DIR_ATTR_DIRECTORY		( (unsigned char)0x10 )	/* fBNg					*/
#define DIR_ATTR_ARCHIVE	 	( (unsigned char)0x20 )	/* kt@C					*/
#define DIR_ATTR_LONG_NAME (DIR_ATTR_READ_ONLY | DIR_ATTR_HIDDEN | DIR_ATTR_SYSTEM | DIR_ATTR_VOLUME_ID ) /* Ot@C */

#define DIR_TOTAL_FILE_PATH		( 260 )					/* t@CpX̍ő咷			*/

/********************************************************/
/* Ot@CfBNgtH[}bg								*/
/********************************************************/
#define LDIR_ORD				( 0 )					/* 1  邩H 0x40 Ń}XNĂPȂ炱̃R[hŏIB	*/
#define LDIR_NAME1				( 1 )					/* 10 t@C1		*/
#define LDIR_ATTRIBUTE			( 11 )					/* 1  			*/
#define LDIR_TYPE				( 12 )					/* 1  				*/
#define LDIR_CHKSUM				( 13 )					/* 1  `FbNT		*/
#define LDIR_NAME2				( 14 )					/* 12 t@CQ		*/

/* 2  Must be ZERO. This is an artifact of the FAT "first cluster" 		*/
/*    and must be zero for compatibility with existing disk utilities.	*/
/*    It's meaningless in the context of a long dir entry.				*/
#define LDIR_FST_CLUST_LO		( 26 )
#define LDIR_NAME3				( 28 )					/* 4  t@CR	*/

#define LDIR_FLNAME_TOTAL		( 255 )					/* Ot@C̍ő咷ij	*/

/********************************************************/
/* FAT ֘A												*/
/********************************************************/
#define RF_CLUSTER_NUM_FAT12	( RF_F_CLUST_FAT12_MAX - 1 )	/* FAT12 ő̃NX^	*/
#define RF_CLUSTER_NUM_FAT16	( RF_F_CLUST_FAT16_MAX - 1 )	/* FAT16 ő̃NX^	*/

/* FAT12 ̃}[N */
#define RF_F_CLUST_FAT12_FREE		( 0x0000 )			/* 󂫃NX^					*/
#define RF_F_CLUST_FAT12_TERMINATE	( 0x0fff )			/* I[NX^					*/
#define RF_F_CLUST_FAT12_BROKEN		( 0x0ffe )			/* ꂽNX^				*/
#define RF_F_CLUST_FAT12_MAX		( 0x0ff5 )			/* NX^ԍől			*/
#define RF_F_CLUST_FAT12_FIRST		( 0x0ff8 )			/* JnNX^					*/

/* FAT16 ̃}[N */
#define RF_F_CLUST_FAT16_FREE		( 0x0000 )			/* 󂫃NX^					*/
#define RF_F_CLUST_FAT16_TERMINATE	( 0xffff )			/* I[NX^					*/
#define RF_F_CLUST_FAT16_BROKEN		( 0xfffe )			/* ꂽNX^				*/
#define RF_F_CLUST_FAT16_MAX		( 0xfff5 )			/* NX^ԍől			*/
#define RF_F_CLUST_FAT16_FIRST		( 0xfff8 )			/* JnNX^					*/

/********************************************************/
/*														*/
/********************************************************/
#define RF_MAX_FILE_PATH			( 4096 )			/* pX̍ő咷				*/

#endif /* RF_DRIVE_LAYOUT_H */
