/****************************************************************************/
/* T  vF write,read {IȓeXg									*/
/*   F 																*/
/* 쐬F 2004.11.14														*/
/* XVF 2014.02.15														*/
/* Copyright    resove														*/
/****************************************************************************/
/* write Ȃ̃t@C read 					*/
/* readŃt@C̃TCY擾							*/
/* caution 2005.10.07									*/
/* writełTCY擾肽							*/

#include "RfInterface.h"
#include "RfGeneral.h"
#include "TraceOut.h"
#include "TstDefine.h"
#include "TstWriteVal.h"
#include "TstGeneral.h"
#include "TstWriteFunc.h"

/* ֐^錾 */
static void readyEnv( void );
static void TestWrite( void );
static void TestRwOld(void);
static void TestRwNew(void);
static void TestCreate(void);
static void TestNotWrite(void);
static void TestErrorChar(void);

static void TestRead( void );
static void TestReadSeq( void );
static void readMany( char * pPath );
static void readLarge( char * pFileNm, unsigned long len );
static void readDir( void );

#define MANY_NUM	(5)


/****************************************************************************/
/* T  v																	*/
/*        write read {@\̃eXg										*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void TestWriteRead( void )
{

	TEST_TITLE(("Test write & read"));
	TestReady();

	readyEnv();
	TestWrite();
	TestRead();
	TestReadSeq();
	TestRwOld();
	TestRwNew();
	TestCreate();
	TestNotWrite();
	TestErrorChar();

	TestConclude();
}

/****************************************************************************/
/* T  v																	*/
/*        eXg													*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void readyEnv( void )
{
	unsigned short err;
	err = RfMkDir("\\@SUBDIR");
	CHK_ERR_CODE(err, RF_OK,  "mkdir()");
}

/****************************************************************************/
/* T  v																	*/
/*        write ̃eXg													*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void TestWrite( void )
{
	TestWriteLarge( "\\root@512.TXT", 512UL );
	TestWriteLarge( "\\root4k.txt", 4096UL+10UL );
	TestWriteLarge( "\\@SUBDIR\\SUB512.txt", 512UL );
	TestWriteLarge( "\\@SUBDIR\\SUB4K.TXT", 4096UL+10UL );
	TestWriteMany("\\@SUBDIR\\many", MANY_NUM);
	
}

/****************************************************************************/
/* T  v																	*/
/*        read ̃eXg														*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void TestRead( void )
{
	readLarge( "\\root@512.TXT", 512UL );
	readLarge( "\\root4k.txt", 4096UL+10UL );
	readLarge( "\\@SUBDIR\\SUB512.txt", 512UL );
	readLarge( "\\@SUBDIR\\SUB4K.TXT", 4096UL+10UL );
	readMany("\\@SUBDIR\\many");
	readDir();
}

/****************************************************************************/
/* T  v																	*/
/*        read V[PVANZXœKIvṼeXg				*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void TestReadSeq( void )
{
	unsigned short err;
	unsigned long size;
	unsigned long len;
	T_RF_FCB * pFcb;
	unsigned short i;
	char readBuff[2];

	pFcb = RfOpen( "\\root4k.txt", RF_OPEN_READ|RF_OPEN_OPT_SEQ, &err );
	if( pFcb == NULL )					return;
	err = RfGetSize( pFcb, &size );				/* t@CTCY擾@*/
	CHK_ERR_CODE(err, RF_OK, "open OPT_SEQ option.");
	for(i = 0; i< (size/2); i++ )
	{
		len = 2;
		err = RfRead( pFcb, readBuff, &len);
		if( err != RF_OK) 
		{
			CHK_ERR_CODE(err, RF_OK, "read Error.");
			break;
		}
		if( len != 2 )
		{
			CHK_CMP_DEC(len, 2, "read size error." );
			break;
		}
		if( (i % 100) == 0 )
		{
			CHK_CMP_DEC(i, i, "read complete." );
		}
	}
	err = RfClose( pFcb );
	CHK_ERR_CODE(err, RF_OK, "close.");
	
}

/****************************************************************************/
/* T  v																	*/
/*        ǂݎ & ݓ(OLD)										*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void TestRwOld(void)
{
	T_RF_FCB * pFcb;
	unsigned short err;
	char readBuff[8];
	unsigned long len = 0UL;

	pFcb = RfOpen( "\\root4k.txt", RF_OPEN_READ|RF_OPEN_WRITE_OLD, &err );
	CHK_ERR_CODE(err, RF_OK, "open RF_OPEN_READ|RF_OPEN_WRITE_OLD option.");
	if( pFcb == NULL )						return;

	/* ǂ */
	len = 2;
	err = RfRead( pFcb, readBuff, &len);
	CHK_CMP_DEC(len, 2L, "readSize.");
	CHK_CMP_HEX(constWriteVal[0], readBuff[0], "read val.");
	CHK_CMP_HEX(constWriteVal[1], readBuff[1], "read val.");

	err = RfSeek( pFcb, 0L, RF_SEEK_SET);		/* 擪ɖ߂ */

	/*  */
	readBuff[0] ^= 0xff;
	readBuff[1] ^= 0xff;
	len = 2UL;
	err = RfWrite( pFcb, readBuff, &len);
	CHK_ERR_CODE( err, RF_OK, "write.");

	err = RfSeek( pFcb, 0L, RF_SEEK_SET);		/* 擪ɖ߂ */

	len = 2L;
	err = RfRead( pFcb, readBuff, &len);
	CHK_ERR_CODE(err, RF_OK, "read.");
	CHK_CMP_DEC(len, 2L, "readSize.");
	readBuff[0] ^= 0xff;
	readBuff[1] ^= 0xff;
	CHK_CMP_HEX(constWriteVal[0], readBuff[0], "read val.");
	CHK_CMP_HEX(constWriteVal[1], readBuff[1], "read val.");

	RfClose( pFcb );
}

/****************************************************************************/
/* T  v																	*/
/*        ǂݎ & ݓ(NEW)										*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void TestRwNew(void)
{
	T_RF_FCB * pFcb;
	unsigned short err;
	char buff[4];
	unsigned long len = 0UL;
	unsigned long i;

	pFcb = RfOpen( "\\rootnew.txt", RF_OPEN_READ|RF_OPEN_WRITE_NEW, &err );
	CHK_ERR_CODE(err, RF_OK, "open RF_OPEN_READ|RF_OPEN_WRITE_NEW option.");
	if( pFcb == NULL )						return;

	/* ǂ */
	len = 2UL;
	err = RfRead( pFcb, buff, &len);
	CHK_ERR_CODE( err, RF_ERR_EOF, "write.");

	/*  */
	buff[0] = 'A';
	buff[1] = 'B';
	len = 2UL;
	err = RfWrite( pFcb, buff, &len );
	CHK_ERR_CODE( err, RF_OK, "write.");

	err = RfSeek( pFcb, 0L, RF_SEEK_SET);		/* 擪ɖ߂ */

	/* 񂾂̂ǂ */
	buff[0] = 'C';
	buff[1] = 'D';
	len = 2UL;
	err = RfRead( pFcb, buff, &len);
	CHK_ERR_CODE( err, RF_OK, "read .");
	CHK_CMP_HEX(buff[0], 'A', "read val[0].");
	CHK_CMP_HEX(buff[1], 'B', "read val[1].");

	err = RfSeek( pFcb, 0L, RF_SEEK_SET);		/* 擪ɖ߂ */
	for( i = 0; i < 32L*1024L*3L; i += 4 )		/* 2G ŕNX^ */
	{
		len = 4UL;
		err = RfWrite( pFcb, (char *)&i, &len );
		if( err != RF_OK )
		{
			CHK_ERR_CODE( err, RF_OK, "write.");
			break;
		}
		if( ( i % 10000L ) == 0L )
		{
			TRACE_OUT((" RfWrite count = %ld\n", i));
		}
	}
	TRACE_OUT((" RfWrite count = %ld\n", i));

	/* Ԓn_ǂł݂ */
	err = RfSeek( pFcb, 32L*1024L*2L, RF_SEEK_SET);		/* 擪ɖ߂ */
	len = 4UL;
	err = RfRead( pFcb, buff, &len);
	CHK_ERR_CODE( err, RF_OK, "read.");
	CHK_CMP_DEC( *((unsigned long *)&buff[0]), 32L*1024L*2L, "read val.");

	RfClose( pFcb );
}

/****************************************************************************/
/* T  v																	*/
/*        create Ŋt@CAVKt@C								*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void TestCreate(void)
{
	T_RF_FCB * pFcb;
	unsigned short err;
	char buff[2];
	unsigned long len = 0UL;
	unsigned long size;

	/* t@C̃I[v */
	pFcb = RfOpen( "\\root4k.txt", RF_OPEN_WRITE_CREATE, &err );
	CHK_ERR_CODE(err, RF_OK, "open RF_OPEN_WRITE_CREATE option.");
	if( pFcb == NULL )						return;
	len = 2UL;
	buff[0] = '1';
	buff[1] = '2';
	err = RfWrite( pFcb, buff, &len);
	CHK_ERR_CODE(err, RF_OK, "RfWrite.");
	err = RfGetSize( pFcb, &size );				/* t@CTCY擾@*/
	CHK_ERR_CODE(err, RF_OK, "RfGetSize.");
	CHK_CMP_DEC(size, 2UL, "after write size.");
	err = RfClose( pFcb );
	CHK_ERR_CODE(err, RF_OK, "RfClose.");

	/* emF */
	pFcb = RfOpen( "\\root4k.txt", RF_OPEN_READ, &err );
	CHK_ERR_CODE(err, RF_OK, "open RF_OPEN_WRITE_CREATE option.");
	if( pFcb == NULL )						return;
	len = 2UL;
	buff[0] = '3';
	buff[1] = '4';
	err = RfRead( pFcb, buff, &len);
	CHK_CMP_DEC(len, 2L, "read size.");
	CHK_CMP_HEX(buff[0], '1', "witten value[0].");
	CHK_CMP_HEX(buff[1], '2', "witten value[1].");
	err = RfClose( pFcb );
	CHK_ERR_CODE(err, RF_OK, "RfClose.");


	/* VKt@C̃I[v */
	pFcb = RfOpen( "\\root2b.txt", RF_OPEN_WRITE_CREATE, &err );
	if( pFcb == NULL )						return;
	CHK_ERR_CODE(err, RF_OK, "open");
	len = 2UL;
	buff[0] = 'A';
	buff[1] = 'B';
	err = RfWrite( pFcb, buff, &len);
	CHK_ERR_CODE(err, RF_OK, "RfWrite.");
	err = RfClose( pFcb );
	CHK_ERR_CODE(err, RF_OK, "RfClose.");
	
	/* emF */
	pFcb = RfOpen( "\\root2b.txt", RF_OPEN_READ, &err );
	CHK_ERR_CODE(err, RF_OK, "open");
	if( pFcb == NULL )						return;
	len = 2UL;
	buff[0] = 'D';
	buff[1] = 'E';
	err = RfRead( pFcb, buff, &len);
	CHK_CMP_DEC(len, 2L, "read size.");
	CHK_CMP_HEX(buff[0], 'A', "witten value[0].");
	CHK_CMP_HEX(buff[1], 'B', "witten value[1].");
	err = RfClose( pFcb );
	CHK_ERR_CODE(err, RF_OK, "RfClose.");
}

/****************************************************************************/
/* T  v																	*/
/*        ܂ATCY 0 ̃t@C								*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void TestNotWrite(void)
{
	T_RF_FCB * pFcb;
	unsigned short err = RF_OK;
	unsigned long size;

	pFcb = RfOpen( "\\rootnotw.txt", RF_OPEN_WRITE_NEW, &err );
	CHK_ERR_CODE(err, RF_OK, "RfOpen. NOT Write Case.");
	if( pFcb == NULL )						return;
	err = RfClose(pFcb);
	CHK_ERR_CODE(err, RF_OK, "RfClose.");

	pFcb = RfOpen( "\\rootnotw.txt", RF_OPEN_WRITE_OLD, &err );
	CHK_ERR_CODE( err, RF_OK, "RfOpen.");
	if( pFcb == NULL )						return;
	err = RfGetSize( pFcb, &size );				/* t@CTCY擾@*/
	CHK_CMP_DEC( size, 0L, "not write size.");
	err = RfClose( pFcb );
	CHK_ERR_CODE( err, RF_OK, "RfClose.");
}

/****************************************************************************/
/* T  v																	*/
/*        t@Cgp֎~̊mF										*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void TestErrorChar(void)
{
	T_RF_FCB * pFcb;
	unsigned short err = RF_OK;

	/* t@C̎gp֎~ */

	pFcb = RfOpen( "\\\x80\x80""abc.txt", RF_OPEN_WRITE_NEW, &err );
	CHK_ERR_CODE(err, RF_ERR_INVALID_NAME, "RfOpen. [NG]Case.");
	if( pFcb != NULL )
	{
		err = RfClose(pFcb);
	}

	pFcb = RfOpen( "\\abc\xe0\xf0.txt", RF_OPEN_WRITE_NEW, &err );
	CHK_ERR_CODE(err, RF_ERR_INVALID_NAME, "RfOpen. [NG]Case.");
	if( pFcb != NULL )
	{
		err = RfClose(pFcb);
	}
	
}


/****************************************************************************/
/* T  v																	*/
/*        t@Cǂ												*/
/* p[^																*/
/*        pPathFt@Ci[ʒũpX										*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void readMany( char * pPath )
{
	T_RF_FCB * pFcb;
	unsigned short err;
	unsigned long len;
	unsigned short i;
	char flName[32];
	char readBuff[32];
	char editBuff[64];
	unsigned short nameIx;
	unsigned long size =0UL;

	for( i = 0; pPath[i] != '\0'; ++i )
	{
		flName[i] = pPath[i];
	}

	nameIx = i;
	for( i = 0; i < MANY_NUM; ++i )
	{
		numToChar( &flName[nameIx], (unsigned long)i, 1000L);
		pFcb = RfOpen( flName, RF_OPEN_READ, &err );
		rfStrCpy(editBuff, "RfOpen()", 64);
		rfStrCat(editBuff, flName, 64, 32);
		CHK_ERR_CODE(err, RF_OK, editBuff);
		if( pFcb )
		{
			err = RfGetSize( pFcb, &size );				/* t@CTCY擾@*/
			CHK_ERR_CODE(err, RF_OK, " RfGetSize() return code.");
			CHK_CMP_DEC(size, nameIx+3, "RfGetSize() file size." );

			len = nameIx + 3;
			err = RfRead( pFcb, readBuff, &len);
			if( len )
			{
				CHK_CMP_STR(flName, readBuff, "check value.");
			}
			CHK_ERR_CODE(err, RF_OK, "RfRead()");
			err = RfClose( pFcb );
			CHK_ERR_CODE(err, RF_OK, "RfClose()");
		}
	}
	
}

/****************************************************************************/
/* T  v																	*/
/*        fBNgI[văG[ɂȂP[X						*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void readDir( void )
{
	unsigned short err = RF_OK;

	RfOpen("\\@SUBDIR", RF_OPEN_READ, &err);
	CHK_ERR_CODE(err, RF_ERR_DIRECTORY, "RfOpen() directory[NG case]");
}

/****************************************************************************/
/* T  v																	*/
/*        傫f[^ǂ												*/
/* p[^																*/
/*        pFileNmFt@C												*/
/*        len    Ft@C̒											*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void readLarge( char * pFileNm, unsigned long len )
{
	T_RF_FCB * pFcb;
	unsigned short err;
	char takeBuff[16];
	unsigned long takeLen;
	unsigned short orgIx;
	unsigned short i,j;
	unsigned long readLen = 0UL;
	unsigned long size = 0UL;

	pFcb = RfOpen( pFileNm, RF_OPEN_READ, &err );
	CHK_ERR_CODE(err, RF_OK, "RfOpen() readLarge");
	if( pFcb )
	{
		err = RfGetSize( pFcb, &size );
		CHK_CMP_DEC(size, len, "check size.");
		CHK_ERR_CODE(err, RF_OK, "RfGetSize()");
		err = RF_OK;
		orgIx = 0;
		while( err == RF_OK )
		{
			takeLen = 16L;
			err = RfRead( pFcb, takeBuff, &takeLen);
			readLen += takeLen;
			if( (err == RF_OK) || (err == RF_ERR_EOF) )
			{
				for( i = 0; i < takeLen; ++i )
				{
					if( takeBuff[i] != constWriteVal[orgIx] )
					{
						TRACE_OUT(("NG\n"));
						TRACE_OUT(("   value Error. ix(%d), dump point(%d)\n", orgIx, orgIx - i));
						TRACE_OUT(("   get:"));
						for( j = 0; j < 16; ++j)
						{
							TRACE_OUT(("%c",takeBuff[j]));
						}
						TRACE_OUT(("\n"));
						TRACE_OUT(("   org:"));
						for( j = 0; j < 16; ++j)
						
						{
							TRACE_OUT(("%c",constWriteVal[orgIx + j - i]));
						}
						TRACE_OUT(("\n"));
						orgIx += 16-i;
						break;
					}
					++orgIx;
				}
			}
			else
			{
				CHK_ERR_CODE(err, RF_OK, "RfRead()");
				break;
			}
		}
		CHK_CMP_DEC(len, readLen, "read Length error." );
		err = RfClose( pFcb );
		CHK_ERR_CODE(err, RF_OK, "RfClose()");
	}

}

